Package: vdiffr
Title: Visual Regression Testing and Graphical Diffing
Version: 1.0.9
Authors@R: c(
    person("Lionel", "Henry", , "lionel@posit.co", role = "aut"),
    person("Thomas Lin", "Pedersen", , "thomas.pedersen@posit.co", role = c("cre", "aut"),
           comment = c(ORCID = "0000-0002-5147-4711")),
    person("Posit Software, PBC", role = c("cph", "fnd")),
    person("T Jake", "Luciani", , "jake@apache.org", role = "aut",
           comment = "svglite"),
    person("Matthieu", "Decorde", , "matthieu.decorde@ens-lyon.fr", role = "aut",
           comment = "svglite"),
    person("Vaudor", "Lise", , "lise.vaudor@ens-lyon.fr", role = "aut",
           comment = "svglite"),
    person("Tony", "Plate", role = "ctb",
           comment = "svglite: Early line dashing code"),
    person("David", "Gohel", role = "ctb",
           comment = "svglite: Line dashing code and raster code"),
    person("Yixuan", "Qiu", role = "ctb",
           comment = "svglite: Improved styles; polypath implementation"),
    person("Håkon", "Malmedal", role = "ctb",
           comment = "svglite: Opacity code")
  )
Description: An extension to the 'testthat' package that makes it easy to
    add graphical unit tests. It provides a Shiny application to manage
    the test cases.
License: MIT + file LICENSE
URL: https://vdiffr.r-lib.org/, https://github.com/r-lib/vdiffr
BugReports: https://github.com/r-lib/vdiffr/issues
Depends: R (>= 4.0)
Imports: diffobj, glue, grDevices, htmltools, lifecycle, rlang,
        testthat (>= 3.0.3), xml2 (>= 1.0.0)
Suggests: covr, decor, ggplot2 (>= 3.2.0), roxygen2, withr
LinkingTo: cpp11
ByteCompile: true
Config/Needs/website: tidyverse/tidytemplate
Encoding: UTF-8
RoxygenNote: 7.3.2
SystemRequirements: libpng
NeedsCompilation: yes
Packaged: 2026-02-12 12:25:53 UTC; lionel
Author: Lionel Henry [aut],
  Thomas Lin Pedersen [cre, aut] (ORCID:
    <https://orcid.org/0000-0002-5147-4711>),
  Posit Software, PBC [cph, fnd],
  T Jake Luciani [aut] (svglite),
  Matthieu Decorde [aut] (svglite),
  Vaudor Lise [aut] (svglite),
  Tony Plate [ctb] (svglite: Early line dashing code),
  David Gohel [ctb] (svglite: Line dashing code and raster code),
  Yixuan Qiu [ctb] (svglite: Improved styles; polypath implementation),
  Håkon Malmedal [ctb] (svglite: Opacity code)
Maintainer: Thomas Lin Pedersen <thomas.pedersen@posit.co>
Repository: CRAN
Date/Publication: 2026-02-13 08:20:02 UTC
Built: R 4.6.0; x86_64-apple-darwin20; 2026-04-28 15:06:04 UTC; unix
Archs: vdiffr.so.dSYM

Package: vdiffr
Title: Visual Regression Testing and Graphical Diffing
Version: 1.0.9
Authors@R: c(
    person("Lionel", "Henry", , "lionel@posit.co", role = "aut"),
    person("Thomas Lin", "Pedersen", , "thomas.pedersen@posit.co", role = c("cre", "aut"),
           comment = c(ORCID = "0000-0002-5147-4711")),
    person("Posit Software, PBC", role = c("cph", "fnd")),
    person("T Jake", "Luciani", , "jake@apache.org", role = "aut",
           comment = "svglite"),
    person("Matthieu", "Decorde", , "matthieu.decorde@ens-lyon.fr", role = "aut",
           comment = "svglite"),
    person("Vaudor", "Lise", , "lise.vaudor@ens-lyon.fr", role = "aut",
           comment = "svglite"),
    person("Tony", "Plate", role = "ctb",
           comment = "svglite: Early line dashing code"),
    person("David", "Gohel", role = "ctb",
           comment = "svglite: Line dashing code and raster code"),
    person("Yixuan", "Qiu", role = "ctb",
           comment = "svglite: Improved styles; polypath implementation"),
    person("Håkon", "Malmedal", role = "ctb",
           comment = "svglite: Opacity code")
  )
Description: An extension to the 'testthat' package that makes it easy to
    add graphical unit tests. It provides a Shiny application to manage
    the test cases.
License: MIT + file LICENSE
URL: https://vdiffr.r-lib.org/, https://github.com/r-lib/vdiffr
BugReports: https://github.com/r-lib/vdiffr/issues
Depends: R (>= 4.0)
Imports: diffobj, glue, grDevices, htmltools, lifecycle, rlang,
        testthat (>= 3.0.3), xml2 (>= 1.0.0)
Suggests: covr, decor, ggplot2 (>= 3.2.0), roxygen2, withr
LinkingTo: cpp11
ByteCompile: true
Config/Needs/website: tidyverse/tidytemplate
Encoding: UTF-8
RoxygenNote: 7.3.2
SystemRequirements: libpng
NeedsCompilation: yes
Packaged: 2026-02-12 12:25:53 UTC; lionel
Author: Lionel Henry [aut],
  Thomas Lin Pedersen [cre, aut] (ORCID:
    <https://orcid.org/0000-0002-5147-4711>),
  Posit Software, PBC [cph, fnd],
  T Jake Luciani [aut] (svglite),
  Matthieu Decorde [aut] (svglite),
  Vaudor Lise [aut] (svglite),
  Tony Plate [ctb] (svglite: Early line dashing code),
  David Gohel [ctb] (svglite: Line dashing code and raster code),
  Yixuan Qiu [ctb] (svglite: Improved styles; polypath implementation),
  Håkon Malmedal [ctb] (svglite: Opacity code)
Maintainer: Thomas Lin Pedersen <thomas.pedersen@posit.co>
Repository: CRAN
Date/Publication: 2026-02-13 08:20:02 UTC
Built: R 4.6.0; x86_64-apple-darwin20; 2026-04-25 18:40:14 UTC; unix
Archs: vdiffr.so.dSYM

Package: mockpkg
Title: title
License: GPL-2
Description: Package description.
Author: author <author@email.com>
Maintainer: maintainer <maintainer@email.com>
Version: 0.1
Suggests:
    testthat,
    vdiffr

# vdiffr

<!-- badges: start -->
[![Travis Build Status](https://travis-ci.org/r-lib/vdiffr.svg?branch=master)](https://travis-ci.org/r-lib/vdiffr)
[![AppVeyor Build status](https://ci.appveyor.com/api/projects/status/github/r-lib/vdiffr?branch=master&svg=true)](https://ci.appveyor.com/project/r-lib/vdiffr)
[![Codecov test coverage](https://codecov.io/gh/r-lib/vdiffr/branch/master/graph/badge.svg)](https://codecov.io/gh/r-lib/vdiffr?branch=master)
[![CRAN status](https://www.r-pkg.org/badges/version/vdiffr)](https://cran.r-project.org/package=vdiffr)
<!-- badges: end -->

vdiffr is an extension to the package testthat that makes it easy to
test for visual regressions. It provides a Shiny app to manage failed
tests and visually compare a graphic to its expected output.


## Installation

Get the development version from github with:

```{r}
# install.packages("remotes")
remotes::install_github("r-lib/vdiffr")
```

or the last CRAN release with:

```{r}
install.packages("vdiffr")
```


## How to use vdiffr

Getting started with vdiffr is a three step process:

1) Add expectations to by including `expect_doppelganger()` in your test files.

1) Run `manage_cases()` to generate the plots which vdiffr will test against in
the future. This will launch a shiny gadget which will ask you to confirm
that each plot is correct.

1) Run `devtools::test()` to execute the tests as normal.

When a figure doesn't matched the saved version, vdiffr signals a failure when it is run interactively, or when it is run on Travis or Appveyor. Mismatches do not cause R CMD check to fail on CRAN machines. See the testing versus monitoring section below.


### Adding expectations

vdiffr integrates with testthat through the `expect_doppelganger()`
expectation. It takes as arguments:

- A title. This title is used in two ways. First, the title is
  standardised (it is converted to lowercase and any character that is
  not alphanumeric or a space is turned into a dash) and used as
  filename for storing the figure. Secondly, with ggplot2 figures the
  title is automatically added to the plot with `ggtitle()` (only if
  no ggtitle has been set).

- A figure. This can be a ggplot object, a recordedplot, a function to
  be called, or more generally any object with a `print` method.

- Optionally, a path where to store the figures, relative to
  `tests/figs/`. They are stored in a subfolder according to the
  current testthat context by default. Supply `path` to change the
  subfolder.

For example, the following tests will create figures in
`tests/figs/histograms/` called `base-graphics-histogram.svg` and
`ggplot2-histogram.svg`:

```{r}
context("Histograms")

disp_hist_base <- function() hist(mtcars$disp)
disp_hist_ggplot <- ggplot(mtcars, aes(disp)) + geom_histogram()

vdiffr::expect_doppelganger("Base graphics histogram", disp_hist_base)
vdiffr::expect_doppelganger("ggplot2 histogram", disp_hist_ggplot)
```

Note that in addition to automatic ggtitles, ggplot2 figures are
assigned the minimalistic theme `theme_test()` (unless they already
have been assigned a theme).


### Managing the tests

When you have added new test cases or detected regressions, you can
manage those from the R command line with the functions
`collect_cases()`, `validate_cases()`, and `delete_orphaned_cases()`.
However it's easier to run the shiny application `manage_cases()`.
With this app you can:

- Check how a failed case differs from its expected output using three
  widgets: Toggle (click to swap the images), Slide and Diff.

- Validate cases. You can do so groupwise (all new cases or all failed
  cases) or on a case by case basis. When you validate a failed case,
  the old expected output is replaced by the new one.

- Delete orphaned cases. During a refactoring of your unit tests, some
  visual expectations may be removed or renamed. This means that some
  unused figures will linger in the `tests/figs/` folder. These
  figures appear in the Shiny application under the category
  "Orphaned" and can be cleaned up from there.

Both `manage_cases()` and `collect_cases()` take `package` as first
argument, the path to your package sources. This argument has exactly
the same semantics as in devtools. You can use vdiffr tools the same
way as you would use `devtools::check()`, for example. The default is
`"."`, meaning that the package is expected to be found in the current
folder.

All validated cases are stored in `tests/figs/`. This folder may be
handy to showcase the different graphs offered in your package. You
can also keep track of how your plots change as you tweak their layout
and add features by checking the history on Github.


### Running tests

You can run the tests the usual way, for example with
`devtools::test()`. New cases for which you just wrote an expectation
will be skipped. Failed tests will show as an error.


### Testing versus Monitoring

When a figure doesn't match its saved version, it is only reported as a failure under these circumstances:

- When the `NOT_CRAN` environment variable is set. In particular, devtools sets this when running the tests interactively.

- On Travis, Appveyor, or any environment where `Sys.getenv("CI")` is set.

Otherwise, the failure is ignored. The motivation for this is that vdiffr is a monitoring tool and shouldn't cause R CMD check failures on the CRAN machines.

Checking the appearance of a figure is inherently fragile. It is a bit like testing for errors by matching exact error messages. These messages are susceptible to change at any time. Similarly, the appearance of plots depends on a lot of upstream code, such as the way margins and spacing are computed. vdiffr uses a special ggplot2 theme that should change very rarely, but there are just too many upstream factors that could cause breakages. For this reason, figure mismatches are not necessarily representative of actual failures.

Visual testing is not an alternative to writing unit tests for the internal data transformations performed during the creation of your figure. It is more of a monitoring tool that allows you to quickly check how the appearance of your figures changes over time, and to manually assess whether changes reflect actual problems in your packages.

If you need to override the default vdiffr behaviour on CRAN (not recommended) or Travis (for example to run the tests in a particular builds but not others), set the `VDIFFR_RUN_TESTS` environment variable to "true" or "false".


### RStudio integration

An addin to launch `manage_cases()` is provided with vdiffr. Use the
addin menu to launch the Shiny app in an RStudio dialog.

![RStudio addin](https://raw.githubusercontent.com/r-lib/vdiffr/readme/rstudio-vdiffr.png)


### ESS integration

To use the Shiny app as part of ESS devtools integration with `C-c C-w
C-v`, include something like this in your init file:

```lisp
(defun ess-r-vdiffr-manage-cases ()
  (interactive)
  (ess-r-package-send-process "vdiffr::manage_cases(%s)\n"
                              "Manage vdiffr cases for %s"))

(define-key ess-r-package-dev-map "\C-v" 'ess-r-vdiffr-manage-cases)
```


## Debugging

It is sometimes difficult to understand the cause of a failure.  This usually indicates that the plot is not created deterministically. Potential culprits are:

* Some of the plot components depend on random variation. Try setting a seed.

* The plot depends on some system library. For instance sf plots depend on libraries like GEOS and GDAL. It might not be possible to test these plots with vdiffr (which can still be used for manual inspection, add a [testthat::skip()] before the `expect_doppelganger()` call in that case).

To help you understand the causes of a failure, vdiffr automatically logs the SVG diff of all failures when run under R CMD check. The log is located in `tests/vdiffr.Rout.fail` and should be displayed on Travis.

You can also set the `VDIFFR_LOG_PATH` environment variable with `Sys.setenv()` to unconditionally (also interactively) log failures in the file pointed by the variable.


## Implementation

### testthat Reporter

vdiffr extends testthat through a custom `Reporter`.
[Reporters](https://github.com/hadley/testthat/blob/master/R/reporter.R)
are classes (R6 classes in recent versions of testthat) whose
instances collect cases and output a summary of the tests. While
reporters are usually meant to provide output for the end user, you
can also use them in functions to interact with testthat.

vdiffr has a
[special reporter](https://github.com/r-lib/vdiffr/blob/master/R/testthat-reporter.R)
that does nothing but activate a collecter for the visual test
cases. `collect_cases()` calls `devtools::test()` with this
reporter. When `expect_doppelganger()` is called, it first checks
whether the case is new or failed. If that's the case, and if it finds
that vdiffr's collecter is active, it calls the collecter, which in
turns records the current test case.

This enables the user to run the tests with the usual development
tools and get feedback in the form of skipped or failed cases. On the
other hand, when vdiffr's tools are called, we collect information
about the tests of interest and wrap them in a data structure.


### SVG comparison

Comparing SVG files is convenient and should work correctly in most
situations. However, SVG is not suitable for tracking really subtle
changes and regressions. See
[vdiffr's issue #1](https://github.com/r-lib/vdiffr/issues/1) for a
discussion on this. vdiffr may gain additional comparison backends in
the future to make the tests more stringent.

# vdiffr

<!-- badges: start -->
[![CRAN status](https://www.r-pkg.org/badges/version/vdiffr)](https://cran.r-project.org/package=vdiffr)
[![R-CMD-check](https://github.com/r-lib/vdiffr/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/r-lib/vdiffr/actions/workflows/R-CMD-check.yaml)
[![Codecov test coverage](https://codecov.io/gh/r-lib/vdiffr/graph/badge.svg)](https://app.codecov.io/gh/r-lib/vdiffr)
<!-- badges: end -->

vdiffr is a testthat extension for monitoring the appearance of R plots. It generates reproducible SVG files and registers them as [testthat snapshots](https://testthat.r-lib.org/articles/snapshotting.html).


## How to use vdiffr

1) Add graphical expectations by including `expect_doppelganger()` in your test files.

1) Run `devtools::test()`.

1) If `test()` detected new snapshots or changes to existing snapshots, run `testthat::snapshot_review()` to review them.

There may be many reasons for a snapshot to fail. Upstream changes (e.g. to the R graphics engine or to ggplot2) may cause subtle differences in your plots that are not actual failures. For this reason, snapshots do not cause failures on CRAN by default. You will only see failures locally or on CI platforms such as Github Actions.


### Adding expectations

vdiffr integrates with testthat through the `expect_doppelganger()` expectation. It takes as arguments:

- A title. This title is used in two ways. First, the title is standardised (it is converted to lowercase and any character that is not alphanumeric or a space is turned into a dash) and used as filename for storing the figure. Secondly, with ggplot2 figures the title is automatically added to the plot with `ggtitle()` (only if no ggtitle has been set).

- A figure. This can be a ggplot object, a recorded plot, a function to be called, or more generally any object with a `print` method.

The snapshots are recorded in subfolders of the `_snaps/` directory.

```r
disp_hist_base <- function() hist(mtcars$disp)
disp_hist_ggplot <- ggplot(mtcars, aes(disp)) + geom_histogram()

vdiffr::expect_doppelganger("Base graphics histogram", disp_hist_base)
vdiffr::expect_doppelganger("ggplot2 histogram", disp_hist_ggplot)
```

Note that in addition to automatic ggtitles, ggplot2 figures are
assigned the minimalistic theme `theme_test()` (unless they already
have been assigned a theme).


### Debugging

It is sometimes difficult to understand the cause of a doppelganger failure. A frequent cause of failure is undeterministic generation of plots. Potential culprits are:

* Some of the plot components depend on random variation. Try setting a seed, for instance with [`withr::local_seed()`](https://withr.r-lib.org/reference/with_seed.html).

* The plot depends on some system library. For instance sf plots depend on libraries like GEOS and GDAL. It might not be possible to test these plots with vdiffr (which can still be used for manual inspection, add a [testthat::skip()] before the `expect_doppelganger()` call in that case).

To help you understand the causes of a failure, vdiffr automatically logs the SVG diff of all failures when run under R CMD check. The log is located in `tests/vdiffr.Rout.fail` and should be displayed in your CI logs.

You can also set the `VDIFFR_LOG_PATH` environment variable with `Sys.setenv()` to unconditionally (also interactively) log failures in the file pointed by the variable.


### Skipping all vdiffr checks on some platforms

See ggplot2's approach which wraps `expect_doppelganger()` with a version that that calls `testthat::skip()` on the relevant platforms (as determined by environment variables): https://github.com/tidyverse/ggplot2/blob/ddd207e926cc1c1847dc661d9a099b8ec19c4010/tests/testthat/helper-vdiffr.R#L1-L15.


## Building vdiffr

_This section is only relevant for building vdiffr from scratch, as opposed to installing from a pre-built package on CRAN._

Building vdiffr requires the system dependency libpng. As vdiffr doesn't have any build-time configuration, your R configuration must point to libpng's `include` and `lib` folders.

For instance on macOS, install libpng with:

```sh
brew install libpng
```

And make sure your `~/.R/Makevars` knows about Homebrew's `include` and `lib` folders where libpng should now be installed. On arm64 hardware, this would be:

```mk
CPPFLAGS += -I/opt/homebrew/include
LDFLAGS += -L/opt/homebrew/lib
```

# This code creates "src/glyph_dims.h" which inlines the glyph dimensions of
# Liberation and Symbola for all unicode points up until 50000. 
# 
# Changes in the entries of "src/glyph_dims.h" will result in potential failures 
# of visual tests since it will change string dimension calculations. Only 
# update it for very good reasons!

# Create vector of unicode characters
char_num <- seq_len(50000)
res <- 1e4
chars <- eval(
  parse(text = paste0(
    'c("', 
    paste(sprintf("\\U%04X", char_num), collapse = '","'), 
    '")')
  )
)

# Get font files from fontquiver (old vdiffr dependency)
liberation <- fontquiver::font("Liberation", 'Sans', 'Regular')$ttf
symbola <- fontquiver::font("Symbola", 'Symbols', 'Regular')$ttf

# Extract glyph dimensions from Liberation
liberation_glyphs <- systemfonts::glyph_info(chars, res = res, path = liberation)
liberation_glyphs$num <- char_num
liberation_glyphs <- liberation_glyphs[!duplicated(liberation_glyphs$index), ]
liberation_glyphs <- data.frame(
  char = liberation_glyphs$num,
  width = liberation_glyphs$x_advance * 72 / res,
  ascent = vapply(liberation_glyphs$bbox, `[`, numeric(1), 4) * 72 / res,
  descent = -vapply(liberation_glyphs$bbox, `[`, numeric(1), 3) * 72 / res
)
# Extract glyph dimensions from Symbola
symbola_glyphs <- systemfonts::glyph_info(chars, res = res, path = symbola)
symbola_glyphs$num <- char_num
symbola_glyphs <- symbola_glyphs[!duplicated(symbola_glyphs$index), ]
symbola_glyphs <- data.frame(
  char = symbola_glyphs$num,
  width = symbola_glyphs$x_advance * 72 / res,
  ascent = vapply(symbola_glyphs$bbox, `[`, numeric(1), 4) * 72 / res,
  descent = -vapply(symbola_glyphs$bbox, `[`, numeric(1), 3) * 72 / res
)

# Write "src/glyph_dims.h"
def <- c(
  "// Generated by inst/create_glyph_dims.R — Do not edit by hand",
  "#pragma once",
  "#include <unordered_map>",
  "struct Dim {",
  "  double width;",
  "  double ascent;",
  "  double descent;",
  "};",
  "const std::unordered_map<uint32_t, Dim> LIBERATION_DIM = {",
  paste(sprintf(
    "  {%i, {%.4f, %.4f, %.4f}}", 
    liberation_glyphs$char, 
    liberation_glyphs$width, 
    liberation_glyphs$ascent, 
    liberation_glyphs$descent
  ), collapse = ",\n"),
  "};",
  "const std::unordered_map<uint32_t, Dim> SYMBOLA_DIM = {",
  paste(sprintf(
    "  {%i, {%.4f, %.4f, %.4f}}", 
    symbola_glyphs$char, 
    symbola_glyphs$width, 
    symbola_glyphs$ascent, 
    symbola_glyphs$descent
  ), collapse = ",\n"),
  "};"
)
writeLines(def, "src/glyph_dims.h")

make_testcase_file <- function(fig_name) {
  file <- tempfile(fig_name, fileext = ".svg")
  structure(file, class = "vdiffr_testcase")
}

#' Default SVG writer
#'
#' This is the default SVG writer for vdiffr test cases. It uses
#' embedded versions of [svglite](https://svglite.r-lib.org),
#' [harfbuzz](https://harfbuzz.github.io/), and the Liberation and
#' Symbola fonts in order to create deterministic SVGs.
#'
#' @param plot A plot object to convert to SVG. Can be a ggplot2 object,
#'   a [recorded plot][grDevices::recordPlot], or any object with a
#'   [print()][base::print] method.
#' @param file The file to write the SVG to.
#' @param title An optional title for the test case.
#'
#' @export
write_svg <- function(plot, file, title = "") {
  svglite(file)
  on.exit(grDevices::dev.off())
  print_plot(plot, title)
}

print_plot <- function(p, title = "") {
  UseMethod("print_plot")
}

#' @export
print_plot.default <- function(p, title = "") {
  print(p)
}

#' @export
print_plot.ggplot <- function(p, title = "") {
  if (title != "" && !"title" %in% names(p$labels)) {
    p <- p + ggplot2::ggtitle(title)
  }
  if (!length(p$theme)) {
    p <- p + ggplot2::theme_test()
  }
  print(p)
}

#' @export
print_plot.grob <- function(p, title) {
  grid::grid.draw(p)
}

#' @export
print_plot.recordedplot <- function(p, title) {
  grDevices::replayPlot(p)
}

#' @export
print_plot.function <- function(p, title) {
  p()
}

#' Does a figure look like its expected output?
#'
#' @description
#'
#' `expect_doppelganger()` is a testthat expectation for graphical
#' plots. It generates SVG snapshots that you can review graphically
#' with [testthat::snapshot_review()]. You will find more information
#' about snapshotting in the [testthat snapshots
#' vignette](https://testthat.r-lib.org/articles/snapshotting.html).
#'
#' Note that `expect_doppelganger()` requires R version 4.1.0. If run
#' on an earlier version of R, it emits a `testthat::skip()` so that you
#' can still run other checks on old versions of R.
#'
#' @param title A brief description of what is being tested in the
#'   figure. For instance: "Points and lines overlap".
#'
#'   If a ggplot2 figure doesn't have a title already, `title` is
#'   applied to the figure with `ggtitle()`.
#'
#'   The title is also used as file name for storing SVG (in a
#'   sanitized form, with special characters converted to `"-"`).
#' @param fig A figure to test. This can be a ggplot object, a
#'   recordedplot, or more generally any object with a `print` method.
#'
#'   If you need to test a plot with non-printable objects (e.g. base
#'   plots), `fig` can be a function that generates and prints the
#'   plot, e.g. `fig = function() plot(1:3)`.
#' @param path,... `r lifecycle::badge('deprecated')`.
#' @param writer A function that takes the plot, a target SVG file,
#'   and an optional plot title. It should transform the plot to SVG
#'   in a deterministic way and write it to the target file. See
#'   [write_svg()] (the default) for an example.
#' @param cran If `FALSE` (the default), mismatched snapshots only
#'   cause a failure when you run tests locally or in your CI (Github
#'   Actions or any platform that sets the `CI` environment variable).
#'   If `TRUE`, failures may also occur on CRAN machines.
#'
#'   Failures are disabled on CRAN by default because testing the
#'   appearance of a figure is inherently fragile. Changes in the R
#'   graphics engine or in ggplot2 may cause subtle differences in the
#'   aspect of a plot, such as a slightly smaller or larger margin.
#'   These changes will cause spurious failures because you need to
#'   update your snapshots to reflect the upstream changes.
#'
#'   It would be distracting for both you and the CRAN maintainers if
#'   such changes systematically caused failures on CRAN. This is why
#'   snapshot expectations do not fail on CRAN by default and should
#'   be treated as a monitoring tool that allows you to quickly check
#'   how the appearance of your figures changes over time, and to
#'   manually assess whether changes reflect actual problems in your
#'   package.
#'
#'   Internally, this argument is passed to
#'   [testthat::expect_snapshot_file()].
#'
#' @inheritParams testthat::expect_snapshot_file
#'
#' @section Debugging:
#' It is sometimes difficult to understand the cause of a failure.
#' This usually indicates that the plot is not created
#' deterministically. Potential culprits are:
#'
#' * Some of the plot components depend on random variation. Try
#'   setting a seed.
#'
#' * The plot depends on some system library. For instance sf plots
#'   depend on libraries like GEOS and GDAL. It might not be possible
#'   to test these plots with vdiffr.
#'
#' To help you understand the causes of a failure, vdiffr
#' automatically logs the SVG diff of all failures when run under R
#' CMD check. The log is located in `tests/vdiffr.Rout.fail` and
#' should be displayed on Travis.
#'
#' You can also set the `VDIFFR_LOG_PATH` environment variable with
#' `Sys.setenv()` to unconditionally (also interactively) log failures
#' in the file pointed by the variable.
#'
#' @examples
#' if (FALSE) {  # Not run
#'
#' library("ggplot2")
#'
#' test_that("plots have known output", {
#'   disp_hist_base <- function() hist(mtcars$disp)
#'   expect_doppelganger("disp-histogram-base", disp_hist_base)
#'
#'   disp_hist_ggplot <- ggplot(mtcars, aes(disp)) + geom_histogram()
#'   expect_doppelganger("disp-histogram-ggplot", disp_hist_ggplot)
#' })
#'
#' }
#' @export
expect_doppelganger <- function(title,
                                fig,
                                path = deprecated(),
                                ...,
                                writer = write_svg,
                                cran = FALSE,
                                variant = NULL) {
  testthat::local_edition(3)

  if (!is_string(title)) {
    abort("`title` must be a string")
  }
  
  fig_name <- str_standardise(title)
  file <- paste0(fig_name, ".svg")

  # Announce snapshot file before touching `fig` in case evaluation
  # causes an error. This allows testthat to restore the files
  # (see r-lib/testthat#1393).
  testthat::announce_snapshot_file(name = file)

  testcase <- make_testcase_file(fig_name)
  writer(fig, testcase, title)

  if (!missing(...)) {
    lifecycle::deprecate_soft(
      "1.0.0",
      "vdiffr::expect_doppelganger(... = )",
    )
  }
  if (lifecycle::is_present(path)) {
    lifecycle::deprecate_soft(
      "1.0.0",
      "vdiffr::expect_doppelganger(path = )",
    )
  }

  if (is_graphics_engine_stale()) {
    testthat::skip(paste_line(
      "The R graphics engine is too old.",
      "Please update to R 4.1.0 and regenerate the vdiffr snapshots."
    ))
  }

  withCallingHandlers(
    testthat::expect_snapshot_file(
      testcase,
      name = file,
      cran = cran,
      variant = variant,
      compare = testthat::compare_file_text
    ),
    expectation_failure = function(cnd) {
      if (is_snapshot_stale(title, testcase)) {
        warn(paste_line(
          "SVG snapshot generated under a different vdiffr version.",
          "i" = "Please update your snapshots."
        ))
      }

      if (!is_null(snapshotter <- get_snapshotter())) {
        path_old <- snapshot_path(snapshotter, file)
        path_new <- snapshot_path(snapshotter, paste0(fig_name, ".new.svg"))

        if (all(file.exists(path_old, path_new))) {
          push_log(fig_name, path_old, path_new)
        }
      }
    }
  )
}

# From testthat
get_snapshotter <- function() {
  x <- getOption("testthat.snapshotter")
  if (is.null(x)) {
    return()
  }

  if (!x$is_active()) {
    return()
  }

  x
}
snapshot_path <- function(snapshotter, file) {
  file.path(snapshotter$snap_dir, snapshotter$file, file)
}

is_graphics_engine_stale <- function() {
  getRversion() < "4.1.0"
}

str_standardise <- function(s, sep = "-") {
  stopifnot(is_scalar_character(s))
  s <- gsub("[^a-z0-9]", sep, tolower(s))
  s <- gsub(paste0(sep, sep, "+"), sep, s)
  s <- gsub(paste0("^", sep, "|", sep, "$"), "", s)
  s
}

is_snapshot_stale <- function(title, testcase) {
  if (is_null(snapshotter <- get_snapshotter())) {
    return(FALSE)
  }

  file <- paste0(str_standardise(title), ".svg")
  path <- snapshot_path(snapshotter, file)

  if (!file.exists(path)) {
    return(FALSE)
  }

  lines <- readLines(path)

  match <- regexec(
    "data-engine-version='([0-9.]+)'",
    lines
  )
  match <- Filter(length, regmatches(lines, match))

  # Old vdiffr snapshot that doesn't embed a version
  if (!length(match)) {
    return(TRUE)
  }

  if (length(match) > 1) {
    abort("Found multiple vdiffr engine versions in SVG snapshot.")
  }

  snapshot_version <- match[[1]][[2]]
  svg_engine_ver() != snapshot_version
}

#' @import rlang
#' @importFrom glue glue
#' @useDynLib vdiffr, .registration = TRUE
#' @keywords internal
"_PACKAGE"

SVG_ENGINE_VER <- "2.0"

svg_engine_ver <- function() {
  as.numeric_version(SVG_ENGINE_VER)
}

.onLoad <- function(lib, pkg) {
  set_engine_version(SVG_ENGINE_VER)
}

## usethis namespace: start
#' @importFrom lifecycle deprecated
## usethis namespace: end
NULL

package_version <- function(pkg) {
  as.character(utils::packageVersion(pkg))
}

cat_line <- function(..., trailing = TRUE, file = "") {
  cat(paste_line(..., trailing = trailing), file = file)
}
paste_line <- function(..., trailing = FALSE) {
  lines <- paste(chr(...), collapse = "\n")
  if (trailing) {
    lines <- paste0(lines, "\n")
  }
  lines
}

push_log <- function(name, old_path, new_path) {
  log_path <- Sys.getenv("VDIFFR_LOG_PATH")

  # If no envvar is set, check if we are running under R CMD check. In
  # that case, always push a log file.
  if (!nzchar(log_path)) {
    if (!is_checking_remotely()) {
      return(invisible(FALSE))
    }
    log_path <- testthat::test_path("..", "vdiffr.Rout.fail")
  }

  log_exists <- file.exists(log_path)

  file <- file(log_path, "a")
  on.exit(close(file))

  if (!log_exists) {
    cat_line(
      file = file,
      "Environment:",
      vdiffr_info(),
      ""
    )
  }

  diff_lines <- diff_lines(name, old_path, new_path)
  cat_line(file = file, "", !!!diff_lines, "")
}
is_checking_remotely <- function() {
  nzchar(Sys.getenv("CI")) || !nzchar(Sys.getenv("NOT_CRAN"))
}

diff_lines <- function(name,
                       before_path,
                       after_path) {
  before <- readLines(before_path)
  after <- readLines(after_path)

  diff <- diffobj::diffChr(
    before,
    after,
    format = "raw",
    # For reproducibility
    disp.width = 80
  )
  lines <- as.character(diff)

  paste_line(
    glue("Failed doppelganger: {name} ({before_path})"),
    "",
    !!!lines
  )
}

vdiffr_info <- function() {
  glue(
    "- vdiffr-svg-engine: { SVG_ENGINE_VER }
     - vdiffr: { utils::packageVersion('vdiffr') }"
  )
}

r_font_families <- c("sans", "serif", "mono", "symbol")
r_font_faces <- c("plain", "bold", "italic", "bolditalic", "symbol")

alias_lookup <- function() {
  if (.Platform$OS.type == "windows") {
    serif_font <- "Times New Roman"
    symbol_font <- "Standard Symbols L"
  } else {
    serif_font <- "Times"
    symbol_font <- "Symbol"
  }
  c(
    sans = "Arial",
    serif = serif_font,
    mono = "Courier",
    symbol = symbol_font
  )
}

validate_aliases <- function(system_fonts, user_fonts) {
  system_fonts <- compact(lapply(system_fonts, compact))
  user_fonts <- compact(lapply(user_fonts, compact))

  system_fonts <- lapply(system_fonts, validate_system_alias)
  user_fonts <- ilapply(user_fonts, validate_user_alias)

  aliases <- c(names(system_fonts), names(user_fonts))
  if (any(duplicated(aliases))) {
    stop("Cannot supply both system and font alias", call. = FALSE)
  }

  # Add missing system fonts for base families
  missing_aliases <- setdiff(r_font_families, aliases)
  system_fonts[missing_aliases] <- lapply(alias_lookup()[missing_aliases], gdtools::match_family)

  list(
    system = system_fonts,
    user = user_fonts
  )
}

validate_system_alias <- function(alias) {
  if (!is_scalar_character(alias)) {
    stop("System fonts must be scalar character vector", call. = FALSE)
  }

  matched <- gdtools::match_family(alias)
  if (alias != matched) {
    warning(call. = FALSE,
      "System font `", alias, "` not found. ",
      "Closest match: `", matched, "`")
  }
  matched
}

is_user_alias <- function(x) {
  is.list(x) &&
    (is_scalar_character(x$file) || is_scalar_character(x$ttf)) &&
    (is_scalar_character(x$alias) || is_scalar_character(x$name))
}

validate_user_alias <- function(default_name, family) {
  if (!all(names(family) %in% r_font_faces)) {
    stop("Faces must contain only: `plain`, `bold`, `italic`, `bolditalic`, `symbol`",
      call. = FALSE)
  }

  is_alias_object <- vapply_lgl(family, is_user_alias)
  is_alias_plain <- vapply_lgl(family, is_scalar_character)

  is_valid_alias <- is_alias_object | is_alias_plain
  if (any(!is_valid_alias)) {
    stop(call. = FALSE,
      "The following faces are invalid for `", default_name, "`: ",
      paste0(names(family)[!is_valid_alias], collapse = ", ")
    )
  }

  names <- ifelse(is_alias_plain, default_name, family)
  names <- lapply_if(names, is_alias_object, function(obj) {
    obj$alias %||% obj$name
  })
  files <- lapply_if(family, is_alias_object, function(obj) {
    obj$file %||% obj$ttf
  })

  file_exists <- vapply_lgl(files, file.exists)
  if (any(!file_exists)) {
    missing <- unlist(files)[!file_exists]
    stop(call. = FALSE,
      "Could not find font file: ",
      paste0(missing, collapse = ", ")
    )
  }

  zip(list(name = names, file = files))
}

#' @importFrom gdtools raster_view
NULL

svglite_path <- function(...) {
  file.path("R", "svglite", ...)
}

for (file in list.files(svglite_path(), pattern = "*.R")) {
  source(svglite_path(file), local = TRUE)
}

#' Shiny bindings for graphical comparison widgets
#'
#' Output and render functions for using the Toggle, Slide and Diff
#' widgets within Shiny applications and interactive Rmd documents.
#' Used in [manage_cases()].
#'
#' @param outputId Output variable to read from.
#' @param width,height Must be a valid CSS unit (like `"100\%"`,
#'   `"400px"`, `"auto"`) or a number, which will be coerced to a
#'   string and have `"px"` appended.
#' @param expr An expression that generates a comparison widget.
#' @param env The environment in which to evaluate `expr`.
#' @param quoted Is `expr` a quoted expression (with `quote()`)? This
#'   is useful if you want to save an expression in a variable.
#' @name shinybindings
NULL

#' @rdname shinybindings
#' @export
toggleOutput <- function(outputId, width = "100%", height = "400px") {
  htmlwidgets::shinyWidgetOutput(outputId, "vdiffr-toggle",
    width, height, package = "vdiffr")
}

#' @rdname shinybindings
#' @export
renderToggle <- function(expr, env = parent.frame(), quoted = FALSE) {
  if (!quoted) {
    expr <- substitute(expr)
  }
  htmlwidgets::shinyRenderWidget(expr, toggleOutput, env, quoted = TRUE)
}

#' @rdname shinybindings
#' @export
slideOutput <- function(outputId, width = "100%", height = "400px") {
  htmlwidgets::shinyWidgetOutput(outputId, "vdiffr-slide",
    width, height, package = "vdiffr")
}

#' @rdname shinybindings
#' @export
slideTransition <- function(expr, env = parent.frame(), quoted = FALSE) {
  if (!quoted) {
    expr <- substitute(expr)
  }
  htmlwidgets::shinyRenderWidget(expr, slideOutput, env, quoted = TRUE)
}

#' @rdname shinybindings
#' @export
diffOutput <- function(outputId, width = "100%", height = "400px") {
  htmlwidgets::shinyWidgetOutput(outputId, "vdiffr-diff",
    width, height, package = "vdiffr")
}

#' @rdname shinybindings
#' @export
diffTransition <- function(expr, env = parent.frame(), quoted = FALSE) {
  if (!quoted) {
    expr <- substitute(expr)
  }
  htmlwidgets::shinyRenderWidget(expr, diffOutput, env, quoted = TRUE)
}

#' An SVG Graphics Driver
#'
#' This function produces graphics compliant to the current w3 svg XML
#' standard. The driver output is currently NOT specifying a DOCTYPE DTD.
#'
#' svglite provides two ways of controlling fonts: system fonts
#' aliases and user fonts aliases. Supplying a font alias has two
#' effects. First it determines the \code{font-family} property of all
#' text anchors in the SVG output. Secondly, the font is used to
#' determine the dimensions of graphical elements and has thus an
#' influence on the overall aspect of the plots. This means that for
#' optimal display, the font must be available on both the computer
#' used to create the svg, and the computer used to render the
#' svg. See the \code{fonts} vignette for more information.
#'
#' @param file The file where output will appear.
#' @param height,width Height and width in inches.
#' @param bg Default background color for the plot (defaults to "white").
#' @param pointsize Default point size.
#' @param standalone Produce a standalone svg file? If \code{FALSE}, omits
#'   xml header and default namespace.
#' @param system_fonts Named list of font names to be aliased with
#'   fonts installed on your system. If unspecified, the R default
#'   families \code{sans}, \code{serif}, \code{mono} and \code{symbol}
#'   are aliased to the family returned by
#'   \code{\link[gdtools]{match_family}()}.
#' @param user_fonts Named list of fonts to be aliased with font files
#'   provided by the user rather than fonts properly installed on the
#'   system. The aliases can be fonts from the fontquiver package,
#'   strings containing a path to a font file, or a list containing
#'   \code{name} and \code{file} elements with \code{name} indicating
#'   the font alias in the SVG output and \code{file} the path to a
#'   font file.
#' @references \emph{W3C Scalable Vector Graphics (SVG)}:
#'   \url{http://www.w3.org/Graphics/SVG/Overview.htm8}
#' @author This driver was written by T Jake Luciani
#'   \email{jakeluciani@@yahoo.com} 2012: updated by Matthieu Decorde
#'   \email{matthieu.decorde@@ens-lyon.fr}
#' @seealso \code{\link{pictex}}, \code{\link{postscript}}, \code{\link{Devices}}
#' @examples
#' # Save to file
#' svglite("Rplots.svg")
#' plot(1:11, (-5:5)^2, type = 'b', main = "Simple Example")
#' dev.off()
#'
#' # Supply system font aliases. First check the font can be located:
#' gdtools::match_family("Verdana")
#'
#' # Then supply a list of aliases:
#' fonts <- list(sans = "Verdana", mono = "Times New Roman")
#' svglite("Rplots.svg", system_fonts = fonts)
#' plot.new()
#' text(0.5, 0.5, "Some text", family = "mono")
#' dev.off()
#'
#' # See the fonts vignettes for more options to deal with fonts
#'
#' @keywords device
#' @useDynLib svglite
#' @importFrom Rcpp sourceCpp
#' @importFrom gdtools raster_view
#' @export
svglite <- function(file = "Rplots.svg", width = 10, height = 8,
                    bg = "white", pointsize = 12, standalone = TRUE,
                    system_fonts = list(), user_fonts = list()) {
  aliases <- validate_aliases(system_fonts, user_fonts)
  invisible(svglite_(file, bg, width, height, pointsize, standalone, aliases))
}

#' Access current SVG as a string.
#'
#' This is a variation on \code{\link{svglite}} that makes it easy to access
#' the current value as a string.
#'
#' See \code{\link{svglite}()} documentation for information about
#' specifying fonts.
#'
#' @param ... Arguments passed on to \code{\link{svglite}}.
#' @return A function with no arguments: call the function to get the
#'   current value of the string.
#' @examples
#' s <- svgstring(); s()
#'
#' plot.new(); s();
#' text(0.5, 0.5, "Hi!"); s()
#' dev.off()
#'
#' s <- svgstring()
#' plot(rnorm(5), rnorm(5))
#' s()
#' dev.off()
#' @inheritParams svglite
#' @export
svgstring <- function(width = 10, height = 8, bg = "white",
                      pointsize = 12, standalone = TRUE,
                      system_fonts = list(), user_fonts = list()) {
  aliases <- validate_aliases(system_fonts, user_fonts)

  env <- new.env(parent = emptyenv())
  string_src <- svgstring_(env, width = width, height = height, bg = bg,
    pointsize = pointsize, standalone = standalone, aliases = aliases)

  function() {
    svgstr <- if(env$is_closed) env$svg_string else get_svg_content(string_src)
    structure(svgstr, class = "svg")
  }
}

#' @export
print.svg <- function(x, ...) cat(x, "\n", sep = "")

# Generated by cpp11: do not edit by hand

compare_files <- function(expected, test) {
  .Call(`_vdiffr_compare_files`, expected, test)
}

svglite_ <- function(file, bg, width, height, pointsize, standalone, always_valid) {
  .Call(`_vdiffr_svglite_`, file, bg, width, height, pointsize, standalone, always_valid)
}

svgstring_ <- function(env, bg, width, height, pointsize, standalone) {
  .Call(`_vdiffr_svgstring_`, env, bg, width, height, pointsize, standalone)
}

get_svg_content <- function(p) {
  .Call(`_vdiffr_get_svg_content`, p)
}

set_engine_version <- function(version) {
  invisible(.Call(`_vdiffr_set_engine_version`, version))
}

context("File comparison")

write_tempfile <- function(lines) {
  path <- tempfile()

  file <- file(path)
  open(file, "w")
  writeLines(lines, file)
  close(file)

  path
}

test_that("files are correctly compared", {
  original <- write_tempfile(letters)
  good <- write_tempfile(letters)
  bad <- write_tempfile(LETTERS)

  expect_true(compare_files(original, good))
  expect_false(compare_files(original, bad))
})

test_that("CR are removed before comparison", {
  crlf_path <- tempfile()
  lf_path <- tempfile()
  writeChar("foo\r\nbar\nbaz\r\nbam", crlf_path, useBytes = TRUE)
  writeChar("foo\nbar\nbaz\nbam", lf_path, useBytes = TRUE)

  expect_true(compare_files(lf_path, crlf_path))
})

#' Manage visual test cases with a Shiny app
#'
#' @inheritParams devtools::test
#' @inheritParams shiny::shinyApp
#' @param package Package description, can be path or package
#'   name. See [devtools::as.package()] for more information.
#' @param invert should the regexp supplied to `filter` be inverted? Defaults to `FALSE`.
#' @param ... Unused.
#' @seealso [vdiffrAddin()], [collect_cases()], and [validate_cases()]
#' @export
manage_cases <- function(package = ".", filter = NULL,
                         invert = FALSE, ..., options = list()) {
  cases <- collect_cases(package, filter = filter, invert = invert)
  cases <- filter_cases(cases, c("new_case", "mismatch_case", "orphaned_case", "success_case"))

  vdiffrApp <- shiny::shinyApp(
    ui = vdiffrUi(cases),
    server = vdiffrServer(cases),
    options = options
  )
  shiny::runApp(vdiffrApp)
}

#' RStudio Addin for managing visual cases
#'
#' The package is detected by looking for the currently active
#' project, then for the current folder if no project is active.
#' @seealso [manage_cases()], [collect_cases()], and [validate_cases()]
#' @export
vdiffrAddin <- function() {
  pkg_path <- rstudioapi::getActiveProject() %||% "."
  cases <- collect_cases(pkg_path)
  cases <- filter_cases(cases, c("new_case", "mismatch_case", "orphaned_case", "success_case"))

  vdiffrApp <- shiny::shinyApp(
    ui = vdiffrUi(cases),
    server = vdiffrServer(cases)
  )
  viewer <- shiny::dialogViewer("vdiffr", width = 1000, height = 800)
  shiny::runGadget(vdiffrApp, viewer = viewer)
}

context("New cases")

test_that("New cases are skipped", {
  new_results <- subset_results(test_results, "test-new.R", "New plots are collected")

  msg <- map_chr(new_results, function(result) result$message)
  expected_msg <- "Figure not generated yet: new%s.svg\nPlease run `vdiffr::manage_cases()` to validate the figure."
  expected_msg <- c(sprintf(expected_msg, "1"), sprintf(expected_msg, "2"))
  expect_equal(msg, expected_msg)

  classes <- map_chr(new_results, function(result) class(result)[[1]])
  expected_classes <- rep("expectation_skip", 2)
  expect_equal(classes, expected_classes)
})

test_that("Figs are saved to alternative paths", {
  path1 <- file.path(mock_pkg_dir, "tests", "figs", "path1")
  path2 <- file.path(mock_pkg_dir, "tests", "figs", "path2")
  expect_true(file.exists(file.path(path1, "alt1.svg")))
  expect_true(file.exists(file.path(path2, "alt2.svg")))
})

test_that("Figs are saved in context subfolders", {
  path1 <- file.path(mock_pkg_dir, "tests", "figs", "new-plots")
  path2 <- file.path(mock_pkg_dir, "tests", "figs", "new-plots")
  expect_true(file.exists(file.path(path1, "context1.svg")))
  expect_true(file.exists(file.path(path2, "context2.svg")))
})

create_mock_pkg <- function(pkg = "mock-pkg") {
  dir <- tempfile()

  dir.create(dir, recursive = TRUE)
  file.copy(pkg, dir, recursive = TRUE)

  # Enable `R CMD check` logging
  from <- file.path(dir, pkg)
  to <- paste0(from, ".Rcheck")
  file.rename(from, to)

  to
}

vdiffr_skip_stale()

test_that("Failures are logged", {
  skip_on_cran()

  reporter <- testthat::SilentReporter$new()

  path <- create_mock_pkg()
  vars <- c("CI" = "true")
  suppressMessages(withr::with_envvar(vars,
    testthat::test_dir(
      file.path(path, "tests", "testthat"),
      reporter = reporter,
      stop_on_failure = FALSE,
      stop_on_warning = FALSE
    )
  ))

  log_path <- file.path(path, "tests", "vdiffr.Rout.fail")
  if (!file.exists(log_path)) {
    abort("Can't find log.")
  }

  on.exit(file.remove(log_path))

  log <- readLines(log_path)
  
  results <- reporter$expectations()
  n_expected <- sum(vapply(results, inherits, NA, "expectation_failure"))

  n_logged <- length(grep("Failed doppelganger:", log))
  expect_equal(n_logged, n_expected)
})

context("Thrown error")

collect_silently <- function(pkg) {
  capture.output(suppressMessages(collect_cases(pkg)))
}

test_that("Error during testing is detected", {
  mock_pkg_dir <- create_mock_pkg("mock-pkg-error")
  mock_test_dir <- file.path(mock_pkg_dir, "tests", "testthat")
  expect_error(collect_silently(mock_test_dir), "while collecting vdiffr cases")
})

context("Expectations")

test_that("Mismatches are skipped except on CI and interactively", {
  notcran_result <- subset_results(test_results, "test-failed.R", "mismatches are hard failures when NOT_CRAN is set")[[1]]
  expect_match(notcran_result$message, "Figures don't match: myplot.svg\n")
  expect_is(notcran_result, "expectation_failure")

  failed_result <- subset_results(test_results, "test-failed.R", "mismatches are hard failures when CI is set")[[1]]
  expect_match(failed_result$message, "Figures don't match: myplot.svg\n")
  expect_is(failed_result, "expectation_failure")

  skipped_result <- subset_results(test_results, "test-failed.R", "mismatches are skipped when NOT_CRAN is unset")[[1]]
  expect_match(skipped_result$message, "Skipping on CRAN")
  expect_is(skipped_result, "expectation_skip")
})

test_that("Duplicated expectations issue warning", {
  expect_true(any(grepl("Duplicated expectations: myplot", mock_cases_outputs$warnings)))
})

test_that("Doppelgangers pass", {
  ggplot_result <- subset_results(test_results, "test-passed.R", "ggplot doppelgangers pass")[[1]]
  base_result <- subset_results(test_results, "test-passed.R", "base doppelgangers pass")[[1]]
  expect_is(ggplot_result, "expectation_success")
  expect_is(base_result, "expectation_success")
})

test_that("skip mismatches if vdiffr is stale", {
  withr::local_envvar(c(NOT_CRAN = "true"))
  mock_dir <- create_mock_pkg("mock-pkg-skip-stale")

  mock_test_dir <- file.path(mock_dir, "tests", "testthat")
  test_results <- testthat::test_dir(mock_test_dir, reporter = "silent")
  result <- test_results[[1]]$results[[1]]

  expect_is(result, "expectation_skip")
  expect_match(result$message, "The vdiffr engine is too old")
})

context("Filtering")

test_that("Can filter to test certain cases", {
  mock_pkg_dir <- create_mock_pkg("mock-pkg")
  mock_test_dir <- file.path(mock_pkg_dir, "tests", "testthat")
  cases <- collect_cases(mock_test_dir, filter = "ggplot")
  case_contexts <- purrr::map_chr(cases, "context")
  expect_true(all(case_contexts == "ggplot"))
})

test_that("Can invert filtering of test cases", {
  mock_pkg_dir <- create_mock_pkg("mock-pkg")
  mock_test_dir <- file.path(mock_pkg_dir, "tests", "testthat")
  cases <- collect_cases(mock_test_dir, filter = "ggplot", invert = TRUE)
  case_contexts <- purrr::map_chr(cases, "context")
  expect_false("ggplot" %in% case_contexts)
})

subset_results <- function(results, file, test) {
  subset <- purrr::keep(results, function(result) {
    result$file == file && result$test == test
  })
  subset[[1]]$results
}


mock_pkg_dir <- create_mock_pkg()
mock_test_dir <- file.path(mock_pkg_dir, "tests", "testthat")

vars <- c(
  VDIFFR_LOG_PATH = file.path(mock_pkg_dir, "tests", "vdiffr.Rout.fail"),
  NOT_CRAN = "true"
)
withr::with_envvar(vars, {
  test_results <- testthat::test_dir(
    mock_test_dir,
    reporter = "silent",
    stop_on_failure = FALSE
  )
})

mock_cases_outputs <- purrr::quietly(purrr::safely(collect_cases))(mock_pkg_dir)

quietly_out <- mock_cases_outputs$result
if (inherits(quietly_out$error, "condition")) {
  cat("While collecting testing cases:\n")
  stop(quietly_out$error)
}

log_path <- file.path(mock_pkg_dir, "tests", "vdiffr.Rout.fail")
if (file.exists(log_path)) {
  copied <- file.copy(log_path, "../mock.Rout.fail", overwrite = TRUE)
  if (!copied) {
    warning("Failed to copy mock package log")
  }
}

mock_cases <- quietly_out$result
validate_cases(mock_cases)

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

compare_files <- function(expected, test) {
    .Call(`_vdiffr_compare_files`, expected, test)
}

svglite_ <- function(file, bg, width, height, pointsize, standalone, aliases) {
    .Call(`_vdiffr_svglite_`, file, bg, width, height, pointsize, standalone, aliases)
}

svgstring_ <- function(env, bg, width, height, pointsize, standalone, aliases) {
    .Call(`_vdiffr_svgstring_`, env, bg, width, height, pointsize, standalone, aliases)
}

get_svg_content <- function(p) {
    .Call(`_vdiffr_get_svg_content`, p)
}

library_load <- function() {
    .Call(`_vdiffr_library_load`)
}

test_string_width <- function(string, font_size, font_file) {
    .Call(`_vdiffr_test_string_width`, string, font_size, font_file)
}

test_string_info <- function(string, font_size, font_file) {
    .Call(`_vdiffr_test_string_info`, string, font_size, font_file)
}

#' HTML Widgets for graphical comparison
#'
#' These widgets can be used at the console and embedded in a R
#' Markdown document or Shiny application.
#'
#' The regular versions take plots or functions as `before` and
#' `after` arguments (see [expect_doppelganger()] for details). The
#' versions suffixed with underscores take HTML image sources. These
#' can be paths to SVG files or inlined SVG images. Currently,
#' `widget_diff_()` is compatible only with inlined images.
#'
#' @inheritParams htmlwidgets::createWidget
#' @param before The picture that is taken as reference.
#' @param after The picture against which the reference is compared.
#' @param ... Unused. Meant for collecting unknown arguments and allow
#'   widget extensions.
#' @name htmlwidgets
#' @examples
#' p1 <- function() hist(mtcars$disp)
#' p2 <- function() hist(mtcars$drat)
#'
#' # You can also call these functions in a R Markdown document or
#' # in a Shiny application:
#' widget_toggle(p1, p2)
#' widget_slide(p1, p2)
#' widget_diff(p1, p2)
NULL

#' @rdname htmlwidgets
#' @export
widget_toggle_ <- function(before, after, ..., width = NULL, height = NULL) {
  sources <- list(files = list(before = before, after = after))

  htmlwidgets::createWidget("vdiffr-toggle",
    x = sources,
    width = width,
    height = height,
    package = "vdiffr"
  )
}

#' @rdname htmlwidgets
#' @export
widget_slide_ <- function(before, after, ..., width = NULL, height = NULL) {
  # Drawing a SVG into a canvas requires that the svg node has 'width'
  # and 'height' attributes set. Otherwise the result is oddly cropped.
  sources <- list(before = before, after = after)
  sources <- list(sources = map(sources, svg_add_dims))

  htmlwidgets::createWidget("vdiffr-slide",
    x = sources,
    width = width,
    height = height,
    package = "vdiffr"
  )
}

#' @rdname htmlwidgets
#' @export
widget_diff_ <- function(before, after, ..., width = NULL, height = NULL) {
  sources <- list(before = before, after = after)
  sources <- list(sources = map(sources, svg_add_dims))

  htmlwidgets::createWidget("vdiffr-diff",
    x = sources,
    width = width,
    height = height,
    package = "vdiffr"
  )
}

diff_text_ <- function(before, after, ..., mode = "unified") {
  # https://github.com/brodieG/diffobj/issues/125#issuecomment-414699100
  shiny::HTML(
    as.character(
      diffobj::diffChr(
        before,
        after,
        mode = mode,
        format = 'html',
        style = list(html.output = 'diff.w.style')
      )
    )
  )
}

#' @rdname htmlwidgets
#' @export
widget_toggle <- function(before, after, ..., width = NULL, height = NULL) {
  files <- widget_svgs(before, after)
  widget_toggle_(files$before, files$after, width, height)
}

#' @rdname htmlwidgets
#' @export
widget_slide <- function(before, after, ..., width = NULL, height = NULL) {
  files <- widget_svgs(before, after)
  widget_slide_(files$before, files$after, width, height)
}

#' @rdname htmlwidgets
#' @export
widget_diff <- function(before, after, ..., width = NULL, height = NULL) {
  files <- widget_svgs(before, after)
  widget_diff_(files$before, files$after, width, height)
}

widget_svgs <- function(before, after) {
  out <- suppressMessages(list(
    before = stringSVG(print_plot(before, "")),
    after = stringSVG(print_plot(after, ""))
  ))

  # widget_diff() does not work if SVG doesn't finish with newline
  out <- map(out, paste0, "\n")

  # Inline SVGs so the widget can be easily embedded anywhere
  out <- map(out, as_inline_svg)

  out
}

vdiffrServer <- function(cases) {
  shiny::shinyServer(function(input, output, session) {
    cases <- shiny::reactiveValues(all = cases)
    cases$active <- shiny::reactive({
      stopifnot(is_string(attr(cases$all, "pkg_path")))
      type <- input$type %||% "new_case"
      filter_cases(cases$all, type)
    })

    output$type_controls <- renderTypeInput(input, cases)
    output$case_controls <- renderCaseInput(input, cases$active)

    output$toggle <- renderDiffer(input, cases$active, widget_toggle_)
    output$slide <- renderDiffer(input, cases$active, widget_slide_)
    output$diff <- renderDiffer(input, cases$active, widget_diff_)

    output$diff_text <- renderDiffer(
      input,
      cases$active,
      diff_text_,
      renderer = shiny::renderUI,
      watcher = diff_text_watcher
    )
    output$diff_text_controls <- renderDiffControls(input)

    validateGroupCases(input, cases)
    validateSingleCase(input, cases)

    output$status <- renderStatus(input, cases)
    output$case_context <- renderCaseContext(input, cases)

    toggleValidateBtns(input, session)
    listenToKeys(input, session, cases)

    quitApp(input)
  })
}

diff_text_watcher <- function(input) {
  compact(list(mode = input$mode))
}

prettify_types <- function(x) {
  ifelse(x == "mismatch_case", "Mismatched",
  ifelse(x == "new_case", "New",
  ifelse(x == "success_case", "Validated", "Orphaned")
  ))
}

renderTypeInput <- function(input, reactive_cases) {
  shiny::renderUI({
    cases <- reactive_cases$all

    types <- unique(map_chr(cases, function(case) class(case)[[1]]))
    if (length(types) == 0) {
      return(NULL)
    }

    types <- sort(set_names(types, prettify_types(types)))

    selected <- input$type %||% types[[1]]

    shiny::selectInput(
      inputId = "type",
      label = "Type:",
      choices = types,
      selected = selected
    )
  })
}

renderCaseInput <- function(input, active_cases) {
  shiny::renderUI({
    names <- unique(names(active_cases()))

    if (length(names)) {
      shiny::selectInput(
        inputId = "case",
        label = "Case:",
        choices = names,
        selected = names[[1]]
      )
    }
  })
}

renderDiffControls <- function(input) {
  shiny::renderUI({
    if (!identical(input$active_tab, "diff_text")) {
      return(htmltools::tags$div())
    }

    htmltools::tagList(
      shiny::br(),
      shiny::br(),
      shiny::selectInput(
        "mode", "Select a diff mode",
        choices = c("unified", "sidebyside", "context", "auto")
      )
    )
  })
}

#' @param watcher A function that takes the Shiny input as argument
#'   and returns a list of additional arguments to be passed to the
#'   widget
#' @noRd
renderDiffer <- function(input,
                         active_cases,
                         widget,
                         renderer = renderToggle,
                         watcher = NULL) {
  renderer({
    # When renderDiffer() is first called, renderCaseInput() has not
    # been called yet.
    if (is.null(input$case)) {
      return(NULL)
    }

    case <- active_cases()[[input$case]]

    # Somehow dependencies are not resolved well: renderDiffer() gets
    # called before renderCaseInput(). This can result in a
    # temporarily invalid selected case when input changes.
    if (is.null(case)) {
      return(NULL)
    }

    # Inline the SVGs in a src field for now
    pkg_path <- attr(active_cases(), "pkg_path")
    before_path <- file.path(pkg_path, "tests", "testthat", case$path)

    after <- as_inline_svg(read_file(case$testcase))
    if (is_new_case(case)) {
      before <- after
    } else {
      before <- as_inline_svg(read_file(before_path))
    }

    if (is_null(watcher)) {
      args <- NULL
    } else {
      args <- watcher(input)
    }

    eval_bare(expr(widget(before, after, !!!args)))
  })
}

withdraw_cases <- function(cases) {
  validate_cases(filter_cases(cases, c("new_case", "mismatch_case")))
  delete_orphaned_cases(filter_cases(cases, "orphaned_case"))
}

validateSingleCase <- function(input, reactive_cases) {
  shiny::observeEvent(c(input$case_validation_button, input[["validateCase"]]), {

    cases <- shiny::isolate(reactive_cases$all)
    case <- shiny::isolate(input$case)
    shiny::req(input$case)

    withdraw_cases(cases[case])
    cases[[case]] <- success_case(cases[[case]])

    shiny::isolate(reactive_cases$all <- cases)
  })
}

validateGroupCases <- function(input, reactive_cases, session) {
  shiny::observeEvent(c(input$group_validation_button, input[["validateGroup"]]), {
    active_cases <- shiny::isolate(reactive_cases$active())
    cases <- shiny::isolate(reactive_cases$all)

    if (length(cases) > 0) {
      shiny::req(input$type)
      type <- shiny::isolate(input$type)

      withdraw_cases(active_cases)
      idx <- purrr::map_lgl(cases, inherits, type)
      cases <- purrr::modify_if(cases, idx, success_case)

      shiny::isolate(reactive_cases$all <- cases)
    }
  })
}

renderCaseContext <- function(input, reactive_cases) {
  shiny::renderUI({
    if (length(reactive_cases$active()) > 0 && !is.null(input$case)) {
      active_case <- reactive_cases$active()[[input$case]]
      shiny::p(
        shiny::strong("Context: "),
        shiny::span(
          title = active_case$path %||% "",
          active_case$context %||% "<none>"
        )
      )
    }
  })
}

renderStatus <- function(input, reactive_cases) {
  shiny::renderUI({
    cases <- reactive_cases$all

    if (length(cases) == 0) {
      paragraph <- shiny::p("All done!")
    } else if (input$active_tab == "slide") {
      paragraph <- shiny::p(
        shiny::strong("Slide: "), "Before  |  After"
      )
    } else if (input$active_tab == "toggle") {
      paragraph <- shiny::p(
        shiny::strong("Now Active: "),
        shiny::span(id = "shiny-toggle-status")
      )
    } else {
      paragraph <- shiny::br()
    }

    list(shiny::br(), paragraph)
  })
}

toggleValidateBtns <- function(input, session) {
  shiny::observeEvent(input$type, {
    shiny::req(input$type)
    message <- input$type == "success_case"
    session$sendCustomMessage("toggle-validate-btns-handler", message)
  })
}

listenToKeys <- function(input, session, reactive_cases) {
  shiny::observeEvent(input[["nextCase"]], {
    names <- unique(names(reactive_cases$active()))
    shiny::updateSelectInput(session, "case",
      selected = next_element(input$case, names)
    )
  })
  shiny::observeEvent(input[["prevCase"]], {
    names <- unique(names(reactive_cases$active()))
    shiny::updateSelectInput(session, "case",
      selected = next_element(input$case, names, direction = -1)
    )
  })
  shiny::observeEvent(input[["nextType"]], {
    types <- unique(map_chr(reactive_cases$all, function(case) class(case)[[1]]))
    shiny::updateSelectInput(session, "type",
      selected = next_element(input$type, types)
    )
  })
  shiny::observeEvent(input[["prevType"]], {
    types <- unique(map_chr(reactive_cases$all, function(case) class(case)[[1]]))
    shiny::updateSelectInput(session, "type",
      selected = next_element(input$type, types, direction = -1)
    )
  })
}

quitApp <- function(input) {
  shiny::observe({
    if (input$quit_button > 0) {
      shiny::stopApp()
    }
  })
}

casesCollecter <-
  R6::R6Class("casesCollecter",
    public = list(
      initialize = function(pkg_path) {
        default_deps <- chr()
        private$.cases <- cases(list(), pkg_path, default_deps)
      },

      add_case = function(case) {
        case <- set_names(list(case), case$name)
        private$.cases = c(private$.cases, case)
      },

      add_dep = function(dep) {
        deps <- attr(private$.cases, "deps")
        attr(private$.cases, "deps") <- unique(c(deps, dep))
      },

      get_cases = function() {
        private$.cases
      }
    ),

    private = list(
      .cases = NULL
    )
  )

vdiffr_env <- new.env(parent = emptyenv())

set_active_collecter <- function(collecter) {
  vdiffr_env$active_collecter <- collecter
}

active_collecter <- function() {
  vdiffr_env$active_collecter
}

maybe_collect_case <- function(case) {
  collecter <- active_collecter()

  if (!is.null(collecter)) {
    collecter$add_case(case)
  }
}

expectation_error <- function(exp) {
  exp <- gsub("^expectation_", "", class(exp)[[1]])
  exp == "error"
}

last_error <- new_environment(list(last = NULL))

#' Print last error that occurred during collection
#' @export
last_collection_error <- function() {
  last_error$last
}

vdiffrReporter <-
  R6::R6Class("vdiffrReporter", inherit = testthat::Reporter,
    public = list(
      failure = NULL,
      pkg_path = NULL,

      initialize = function(pkg_path) {
        self$pkg_path <- pkg_path
        collecter <- casesCollecter$new(pkg_path)
        set_active_collecter(collecter)
      },

      add_result = function(context, test, result) {
        cat(single_letter_summary(result))
        private$.result_counter <- private$.result_counter + 1
        if (private$.result_counter >= getOption("width")) {
          cat("\n")
          private$.result_counter <- 0
        }

        case <- attr(result, "vdiffr_case")
        if (expectation_error(result)) {
          self$failure <- result
        }
      },

      end_reporter = function() {
        cat_line()

        if (!is.null(self$failure)) {
          last_error$last <- self$failure
          abort(glue(
            "while collecting vdiffr cases. Last error:
             * test: { self$failure$test }
             * message: { self$failure$message }
             You can inspect this error with `vdiffr::last_collection_error()`"
          ))
        }
      }
    ),
    
    private = list(
      .result_counter = 0
    )
  )

expectation_type <- function(exp) {
  stopifnot(inherits(exp, "expectation"))
  if (inherits(exp, "vdiffr_new")) return("new")
  if (inherits(exp, "vdiffr_mismatch")) return("mismatch")
  if (inherits(exp, "vdiffr_match")) return("match")

  gsub("^expectation_", "", class(exp)[[1]])
}
single_letter_summary <- function(x) {
  switch(expectation_type(x),
    new      = "N",
    mismatch = "X",
    match    = "o",
    skip     = "S",
    success  = ".",
    error    = "E",
    failure  = "F",
    warning  = "W",
    "?"
  )
}

#' @import rlang
#' @importFrom glue glue
#' @importFrom purrr map map_chr keep walk every partial map2_chr compact
#' @importFrom R6 R6Class
#' @importFrom Rcpp sourceCpp
#' @useDynLib vdiffr, .registration = TRUE
"_PACKAGE"

.onLoad <- function(lib, pkg) {
  if (!is_installed("freetypeharfbuzz")) {
    abort("The package `freetypeharfbuzz` is not installed")
  }
  library_load()
}

SVG_ENGINE_VER <- "1.0"

svg_engine_ver <- function() {
  as.numeric_version(SVG_ENGINE_VER)
}

#' Collect cases
#'
#' These functions are mainly intended for internal use by
#' [manage_cases()]. They are useful to programmatically collect
#' cases.
#'
#' @inheritParams manage_cases
#' @seealso [manage_cases()]
#' @return A `cases` object. `collect_new_cases()`,
#'   `collect_mismatched_cases()` and `collect_orphaned_cases()`
#'   return a filtered `cases` object.
#' @export
collect_cases <- function(package = ".", filter = NULL, invert = FALSE) {
  on.exit(set_active_collecter(NULL))

  message("Running testthat to collect visual cases\n\n",
    "  N = New visual case\n  X = Failed doppelganger\n  o = Successful doppelganger\n")
  package <- devtools::as.package(package)
  reporter <- vdiffrReporter$new(package$path)
  suppressMessages(
    devtools::test(
      package,
      filter = filter,
      reporter = reporter,
      invert = invert
    )
  )

  cases <- active_collecter()$get_cases()

  cases_names <- map_chr(cases, "name")
  is_duplicated <- duplicated(cases_names)
  if (any(is_duplicated)) {
    warning(call. = FALSE,
      "Duplicated expectations: ",
      paste(cases_names[is_duplicated], collapse = ", "))
  }

  # Only check for orphaned cases if we have collected all figures in
  # all test files. Ideally we'd check for orphaned cases in the
  # filter set, but there's currently no way of figuring out the
  # files where saved figures were generated from.
  if (is_null(filter)) {
    cases <- c(cases, orphaned_cases(cases))
  }

  cases
}

orphaned_cases <- function(cases) {
  pkg_path <- attr(cases, "pkg_path")
  cases_paths <- map_chr(cases, "path")
  cases_paths <- map_chr(cases_paths, adjust_figs_path, pkg_path)
  cases_paths <- map_chr(cases_paths, normalise_path)

  figs_path <- file.path(pkg_path, "tests", "figs")
  figs_files <- dir(figs_path, ".*\\.svg$", full.names = TRUE, recursive = TRUE)
  figs_files <- map_chr(figs_files, normalise_path)

  # Testcases are absolute, paths are relative to 'testthat' folder
  svg_paths <- map_chr(figs_files, function(path) {
    prefix <- paste0(file.path(pkg_path, "tests"))
    rel_path <- substr(path, nchar(prefix) + 1, nchar(path))
    paste0("..", rel_path)
  })

  is_orphan <- !figs_files %in% cases_paths
  orphans_testcases <- figs_files[is_orphan]
  orphans_paths <- svg_paths[is_orphan]
  orphans_names <- map_chr(orphans_paths, ~str_trim_ext(basename(.x)))

  cases <- purrr::transpose(list(
    name = orphans_names,
    path = orphans_paths,
    testcase = orphans_testcases,
    verbose = rep_along(orphans_names, FALSE)
  ))
  orphaned_cases <- purrr::map(cases, orphaned_case)
  cases(orphaned_cases, pkg_path)
}

#' @rdname collect_cases
#' @export
collect_new_cases <- function(package = ".") {
  filter_cases(collect_cases(package), "new_case")
}

#' @rdname collect_cases
#' @export
collect_mismatched_cases <- function(package = ".") {
  filter_cases(collect_cases(package), "mismatch_case")
}

#' @rdname collect_cases
#' @export
collect_orphaned_cases <- function(package = ".") {
  filter_cases(collect_cases(package), "orphaned_case")
}

#' Cases validation
#'
#' These functions are mainly intended for internal use by
#' [manage_cases()]. They are useful to programmatically validate
#' cases or delete orphaned cases.
#'
#' @seealso [manage_cases()]
#' @param cases A `cases` object returned by one of the collecting
#'   functions such as [collect_cases()].
#' @export
validate_cases <- function(cases = collect_new_cases()) {
  stopifnot(is_cases(cases))
  cases <- filter_cases(cases, c("new_case", "mismatch_case"))

  pkg_path <- attr(cases, "pkg_path")
  if (is.null(pkg_path)) {
    stop("Internal error: Package path is missing", call. = FALSE)
  }

  write_deps_note(pkg_path)
  walk(cases, update_case, pkg_path)
}

write_deps_note <- function(pkg = NULL) {
  pkg <- pkg %||% usethis::proj_get()

  deps_note_file <- file.path(pkg, "tests", "figs", "deps.txt")
  cat_line(vdiffr_info(), file = deps_note_file)
}

update_case <- function(case, pkg_path) {
  path <- file.path(pkg_path, "tests", "figs", case$path)
  ensure_directories(dirname(path))
  file.copy(case$testcase, path, overwrite = TRUE)
}

#' @rdname validate_cases
#' @export
delete_orphaned_cases <- function(cases = collect_orphaned_cases()) {
  stopifnot(is_cases(cases))
  pkg_path <- attr(cases, "pkg_path")
  if (is.null(pkg_path)) {
    stop("Internal error: Package path is missing", call. = FALSE)
  }

  cases <- filter_cases(cases, "orphaned_case")
  paths <- map_chr(cases, "testcase")
  walk(paths, file.remove)
}

# It is brittle to keep `pkg_path` in attributes. Maybe change to an
# R6 object?
cases <- function(x, pkg_path, deps = NULL) {
  structure(x,
    class = "cases",
    pkg_path = pkg_path,
    deps = deps
  )
}

is_cases <- function(case) inherits(case, "cases")

c.cases <- function(..., recursive = FALSE) {
  cases(NextMethod(), attr(..1, "pkg_path"), attr(..1, "deps"))
}

`[.cases` <- function(x, i) {
  cases(NextMethod(), attr(x, "pkg_path"), attr(x, "deps"))
}

#' @export
print.cases <- function(x, ...) {
  cat(sprintf("<cases>: %s\n", length(x)))

  mismatched <- filter_cases(x, "mismatch_case")
  if (length(mismatched) > 0) {
    cat("\nMismatched:\n")
    print_cases_names(mismatched)
  }

  new <- filter_cases(x, "new_case")
  if (length(new) > 0) {
    cat("\nNew:\n")
    print_cases_names(new)
  }

  success <- filter_cases(x, "success_case")
  if (length(success) > 0) {
    cat("\nValidated:\n")
    print_cases_names(success)
  }

  orphaned <- filter_cases(x, "orphaned_case")
  if (length(orphaned) > 0) {
    figs_path <- file.path(attr(x, "pkg_path"), "tests")

    cat("\nOrphaned:\n")
    files <- map_chr(orphaned, "path")
    files <- map_chr(files, function(file) {
      file <- sub(paste0("^", figs_path, .Platform$file.sep), "", file)
      paste0(" - ", file)
    })
    cat(paste(files, collapse = "\n"), "\n")
  }

  invisible(cases)
}

print_cases_names <- function(cases) {
  names <- map_chr(names(cases), function(name) paste0(" - ", name))
  cat(paste(names, collapse = "\n"), "\n")
}

filter_cases <- function(cases, type) {
  filtered <- keep(cases, inherits, type)

  # Restore attributes discarded by purrr::keep()
  cases(filtered, attr(cases, "pkg_path"), attr(cases, "deps"))
}

case <- function(case) {
  structure(case, class = "case")
}
mismatch_case <- function(case) {
  structure(case, class = c("mismatch_case", "case"))
}
new_case <- function(case) {
  structure(case, class = c("new_case", "case"))
}
orphaned_case <- function(case) {
  structure(case, class = c("orphaned_case", "case"))
}
success_case <- function(case) {
  structure(case, class = c("success_case", "case"))
}

is_case <- function(case) {
  inherits(case, "case")
}
is_mismatch_case <- function(case) {
  inherits(case, "mismatch_case")
}
is_new_case <- function(case) {
  inherits(case, "new_case")
}
is_orphaned_case <- function(case) {
  inherits(case, "orphaned_case")
}

context("Cases")

test_that("Attributes are preserved", {
  cases <- vdiffr:::cases(list(), "pkg_path", "deps")
  new_cases <- filter_cases(cases, "new")

  expect_equal(attr(new_cases, "pkg_path"), "pkg_path")
  expect_equal(attr(new_cases, "deps"), "deps")
})

test_that("mock test cases contain context references", {
  mock_contexts <- vapply(mock_cases, function(x) x$context %||% NA_character_, character(1))
  # the two last ones don't have a context...this is ok
  expect_true(any(!is.na(mock_contexts)))
})

context("Orphaned")

test_that("Orphaned figures are found", {
  orphaned <- filter_cases(mock_cases, "orphaned_case")
  expect_equal(map_chr(unname(orphaned), "name"), c("orphaned1", "orphaned2"))
})

test_that("Orphaned files are found and deleted", {
  orphaned <- filter_cases(mock_cases, "orphaned_case")
  files <- map_chr(orphaned, "path")
  files <- map_chr(files, purrr::partial(file.path, mock_pkg_dir, "tests", "testthat"))
  files_exist <- purrr::every(files, file.exists)
  expect_true(files_exist)

  if (files_exist) {
    delete_orphaned_cases(mock_cases)
    expect_false(purrr::some(files, file.exists))
  }
})

#' Does a figure look like its expected output?
#'
#' @description
#'
#' `expect_doppelganger()` takes a figure to check visually.
#'
#' * If the figure has yet to be validated, the test is skipped. Call
#'   [manage_cases()] to validate the new figure, so vdiffr knows what
#'   to compare against.
#'
#' * If the test has been validated, `fig` is compared to the
#'   validated figure. If the plot differs, a failure is issued
#'   (except on CRAN, see section on regression testing below).
#'
#'   Either fix the problem, or call [manage_cases()] to validate the
#'   new figure appearance.
#'
#' @param title A brief description of what is being tested in the
#'   figure. For instance: "Points and lines overlap".
#'
#'   If a ggplot2 figure doesn't have a title already, `title` is
#'   applied to the figure with `ggtitle()`.
#'
#'   The title is also used as file name for storing SVG (in a
#'   sanitzed form, with special characters converted to `"-"`).
#' @param fig A figure to test. This can be a ggplot object, a
#'   recordedplot, or more generally any object with a `print` method.
#'
#'   For plots that can't be represented as printable objects, you can
#'   pass a function. This function must construct the plot and print
#'   it.
#' @param path The path where the test case should be stored, relative
#'   to the `tests/figs/` folder. If `NULL` (the default), the current
#'   testthat context is used to create a subfolder. Supply an empty
#'   string `""` if you want the figures to be stored in the root
#'   folder.
#' @param ... Additional arguments passed to [testthat::compare()] to
#'   control specifics of comparison.
#' @param verbose Soft-deprecated. See the debugging section.
#' @param writer A function that takes the plot, a target SVG file,
#'   and an optional plot title. It should transform the plot to SVG
#'   in a deterministic way and write it to the target file. See
#'   [write_svg()] (the default) for an example.
#'
#' @section Regression testing versus Unit testing:
#'
#' Failures to match a validated appearance are only reported when the
#' tests are run locally, on Travis, Appveyor, or any environment
#' where the `Sys.getenv("CI")` or `Sys.getenv("NOT_CRAN")` variables
#' are set. Because vdiffr is more of a monitoring than a unit testing
#' tool, it shouldn't cause R CMD check failures on the CRAN machines.
#'
#' Checking the appearance of a figure is inherently fragile. It is
#' similar to testing for errors by matching exact error messages:
#' these messages are susceptible to change at any time. Similarly,
#' the appearance of plots depends on a lot of upstream code, such as
#' the way margins and spacing are computed. vdiffr uses a special
#' ggplot2 theme that should change very rarely, but there are just
#' too many upstream factors that could cause breakages. For this
#' reason, figure mismatches are not necessarily representative of
#' actual failures.
#'
#' Visual testing is not an alternative to writing unit tests for the
#' internal data transformations performed during the creation of your
#' figure. It is more of a monitoring tool that allows you to quickly
#' check how the appearance of your figures changes over time, and to
#' manually assess whether changes reflect actual problems in your
#' package.
#'
#' If you need to override the default vdiffr behaviour on CRAN (not
#' recommended) or Travis (for example to run the tests in a
#' particular builds but not others), set the `VDIFFR_RUN_TESTS`
#' environment variable to "true" or "false".
#'
#' @section Debugging:
#'
#' It is sometimes difficult to understand the cause of a failure.
#' This usually indicates that the plot is not created
#' deterministically. Potential culprits are:
#'
#' * Some of the plot components depend on random variation. Try
#'   setting a seed.
#'
#' * The plot depends on some system library. For instance sf plots
#'   depend on libraries like GEOS and GDAL. It might not be possible
#'   to test these plots with vdiffr (which can still be used for
#'   manual inspection, add a [testthat::skip()] before the
#'   `expect_doppelganger()` call in that case).
#'
#' To help you understand the causes of a failure, vdiffr
#' automatically logs the SVG diff of all failures when run under R
#' CMD check. The log is located in `tests/vdiffr.Rout.fail` and
#' should be displayed on Travis.
#'
#' You can also set the `VDIFFR_LOG_PATH` environment variable with
#' `Sys.setenv()` to unconditionally (also interactively) log failures
#' in the file pointed by the variable.
#'
#' @examples
#' if (FALSE) {  # Not run
#'
#' library("ggplot2")
#'
#' test_that("plots have known output", {
#'   disp_hist_base <- function() hist(mtcars$disp)
#'   expect_doppelganger("disp-histogram-base", disp_hist_base)
#'
#'   disp_hist_ggplot <- ggplot(mtcars, aes(disp)) + geom_histogram()
#'   expect_doppelganger("disp-histogram-ggplot", disp_hist_ggplot)
#' })
#'
#' }
#' @export
expect_doppelganger <- function(title,
                                fig,
                                path = NULL,
                                ...,
                                verbose = NULL,
                                writer = write_svg) {
  if (!is_collecting()) {
    abort(paste_line(
      "`expect_doppelganger()` can't be called interactively.",
      "* Call `vdiffr::manage_cases()` to validate or revalidate figures.",
      "* Call `devtools::test()` to test the figures."
    ))
  }

  if (!is_null(verbose)) {
    signal_soft_deprecated(paste_line(
      "The `verbose` argument is soft-deprecated as of vdiffr 0.3.0.",
      "Please use the log file intead. See section 'Debugging' of `?expect_doppelganger`."
    ))
  }

  fig_name <- str_standardise(title)
  testcase <- make_testcase_file(fig_name)
  writer(fig, testcase, title)

  context <- get(".context", envir = testthat::get_reporter())
  context <- str_standardise(context %||% "")
  path <- path %||% context

  # Climb one level as we are in the testthat folder
  path <- file.path(path, paste0(fig_name, ".svg"))
  path <- testthat::test_path("..", "figs", path)
  ensure_directories(dirname(path))

  case <- case(list(
    name = fig_name,
    path = path,
    testcase = testcase,
    context = context
  ))

  if (file.exists(path)) {
    exp <- case_compare(case)
  } else {
    exp <- case_declare(case, fig_name)
  }

  signal_expectation(exp)
}

# FIXME: Use TESTTHAT_PKG envvar after devtools and testthat release
is_collecting <- function() {
  !inherits(testthat::get_reporter(), "StopReporter")
}

str_standardise <- function(s, sep = "-") {
  stopifnot(is_scalar_character(s))
  s <- gsub("[^a-z0-9]", sep, tolower(s))
  s <- gsub(paste0(sep, sep, "+"), sep, s)
  s <- gsub(paste0("^", sep, "|", sep, "$"), "", s)
  s
}

case_compare <- function(case) {
  # Skipping early to avoid running `compare_files()` on machines
  # performing sanitizer checks
  if (!is_ci()) {
    return(new_expectation("Skipping on CRAN", case, "skip", "vdiffr_skip"))
  }

  equal <- compare_files(case$testcase, normalizePath(case$path))

  if (equal) {
    case <- success_case(case)
    maybe_collect_case(case)
    return(match_exp("TRUE", case))
  }

  case <- mismatch_case(case)
  maybe_collect_case(case)

  if (is_null(active_collecter())) {
    push_log(case)
  }

  msg <- paste0("Figures don't match: ", case$name, ".svg\n")
  mismatch_exp(msg, case)
}
case_declare <- function(case, fig_name) {
  case <- new_case(case)
  maybe_collect_case(case)

  msg <- paste_line(
    sprintf("Figure not generated yet: %s.svg", fig_name),
    "Please run `vdiffr::manage_cases()` to validate the figure."
  )
  new_exp(msg, case)
}

new_expectation <- function(msg, case, type, vdiffr_type) {
  exp <- testthat::expectation(type, msg)
  classes <- c(class(exp), vdiffr_type)
  structure(exp, class = classes, vdiffr_case = case)
}

new_exp <- function(msg, case) {
  new_expectation(msg, case, "skip", "vdiffr_new")
}
match_exp <- function(msg, case) {
  new_expectation(msg, case, "success", "vdiffr_match")
}
mismatch_exp <- function(msg, case) {
  if (is_vdiffr_stale()) {
    msg <- "The vdiffr engine is too old. Please update vdiffr and revalidate the figures."
    new_expectation(msg, case, "skip", "vdiffr_mismatch")
  } else if (is_ci()) {
    new_expectation(msg, case, "failure", "vdiffr_mismatch")
  } else {
    new_expectation(msg, case, "skip", "vdiffr_mismatch")
  }
}

# FIXME: Should probably be exported from testthat
signal_expectation <- function(exp) {
  withRestarts(
    if (expectation_broken(exp)) {
      stop(exp)
    } else {
      signalCondition(exp)
    },
    continue_test = function(e) NULL
  )
  invisible(exp)
}
expectation_broken <- function(exp) {
  expectation_type(exp) %in% c("failure", "mismatch", "error")
}

#' Add a vdiffr dependency
#'
#' It is useful to record the version number of all the packages on
#' which your visual test cases depend. A note containing a version
#' number is added to the `DESCRIPTION` file for each dependency.
#' Dependencies on svglite and ggplot2 are automatically added. In
#' addition, `add_dependency()` can be called in any testthat file to
#' manually add a dependency to a package.
#'
#' @param deps A vector containing the names of the packages for which
#'   a dependency should be added.
#'
#' @keywords internal
#' @export
add_dependency <- function(deps) {
  signal_soft_deprecated("`add_dependency()` is soft-deprecated as of vdiffr 0.3.0, without replacement")
  collecter <- active_collecter()
  if (!is.null(collecter)) {
    walk(deps, collecter$add_dep)
  }
}

vdiffrUi <- function(cases) {
  shiny::shinyUI(shiny::fluidPage(
    shiny::singleton(shiny::tags$head(
      include_script("toggle.js")
    )),
    shiny::br(),
    shiny::sidebarLayout(
      sidebarPanel(),
      diffPanel()
    )
  ))
}

sidebarPanel <- function() {
  shiny::sidebarPanel(
    shiny::uiOutput("type_controls"),
    shiny::actionButton("group_validation_button", "Validate these"),
    shiny::br(),
    shiny::br(),
    shiny::uiOutput("case_context"),
    shiny::uiOutput("case_controls"),
    shiny::actionButton("case_validation_button", "Validate this"),
    shiny::uiOutput("status"),
    shiny::uiOutput("diff_text_controls"),
    shiny::br(),
    shiny::actionButton("quit_button", "Quit")
  )
}

diffPanel <- function() {
  shiny::mainPanel(
    shiny::tabsetPanel(id = "active_tab",
      shiny::tabPanel("Toggle", toggleOutput("toggle"), value = "toggle"),
      shiny::tabPanel("Slide", slideOutput("slide"), value = "slide"),
      shiny::tabPanel("Diff", diffOutput("diff"), value = "diff"),
      shiny::tabPanel("Textual Diff", shiny::htmlOutput("diff_text"), value = "diff_text")
    )
  )
}

include_script <- function(file) {
  script <- shiny::includeScript(
    system.file("www", file, package = "vdiffr")
  )
  isolate_scope(script)
}

isolate_scope <- function(script) {
  head <- "(function() {\n"
  tail <- "\n})();"
  script$children[[1]] <- paste0(head, script$children[[1]], tail)
  script
}

library("vdiffr")

p1 <- function() plot(mtcars$disp)
p2 <- ggplot2::ggplot(mtcars, ggplot2::aes(disp)) +
  ggplot2::geom_histogram()

test_that("New plots are collected", {
  expect_doppelganger("new1", p1)
  expect_doppelganger("new2", p2)
})

test_that("errors reset snapshots", {
  if (nzchar(Sys.getenv("VDIFFR_REGENERATE_SNAPS"))) {
    expect_doppelganger("error resets snapshots", function() plot(1:3))
  } else {
    expect_doppelganger("error resets snapshots", function() stop("failing"))
  }
})

test_that("skips reset snapshots", {
  if (nzchar(Sys.getenv("VDIFFR_REGENERATE_SNAPS"))) {
    expect_doppelganger("skip resets snapshots", function() plot(1:3))
  } else {
    expect_doppelganger("skip resets snapshots", function() skip("skipping"))
  }
})

vdiffr_skip_stale()

test_that("ggplot doppelgangers pass", {
  skip_if_not_installed("ggplot2")
  p1_orig <- ggplot2::ggplot(mtcars, ggplot2::aes(disp)) + ggplot2::geom_histogram()
  expect_doppelganger("myplot", p1_orig)
})

test_that("base doppelgangers pass", {
  p_base <- function() plot(mtcars$disp)
  expect_doppelganger("myplot2", p_base)

  p_base_symbol <- function() {
    plot.new()
    text(0.5, 0.8, expression(x[i] + over(x, y)), font = 5)
  }

  expect_doppelganger("Base doppelganger with symbol", p_base_symbol)
})

test_that("grid doppelgangers pass", {
  p_grid <- function() {
    grid::grid.newpage()
    grid::grid.text("foobar", gp = grid::gpar(fontsize = 10.1))
    grid::grid.text("foobaz", 0.5, 0.1, gp = grid::gpar(fontsize = 15.05))
  }
  expect_doppelganger("Grid doppelganger", p_grid)
})

test_that("no 'svglite supports one page' error (#85)", {
  test_draw_axis <- function(add_labels = FALSE) {
    theme <- theme_test() + theme(axis.line = element_line(size = 0.5))
    positions <- c("top", "right", "bottom", "left")

    n_breaks <- 3
    break_positions <- seq_len(n_breaks) / (n_breaks + 1)
    labels <- if (add_labels) as.character(seq_along(break_positions))

    # create the axes
    axes <- lapply(positions, function(position) {
      ggplot2:::draw_axis(break_positions, labels, axis_position = position, theme = theme)
    })
    axes_grob <- gTree(children = do.call(gList, axes))

    # arrange them so there's some padding on each side
    gt <- gtable(
      widths = unit(c(0.05, 0.9, 0.05), "npc"),
      heights = unit(c(0.05, 0.9, 0.05), "npc")
    )
    gtable_add_grob(gt, list(axes_grob), 2, 2, clip = "off")
  }
  environment(test_draw_axis) <- env(ns_env("ggplot2"))

  expect_doppelganger("page-error1", test_draw_axis(FALSE))
  expect_doppelganger("page-error2", test_draw_axis(TRUE))
})

test_that("supports `grob` objects (#36)", {
  circle <- grid::circleGrob(
    x = 0.5,
    y = 0.5,
    r = 0.5,
    gp = grid::gpar(col = "gray", lty = 3)
  )
  expect_doppelganger("grob", circle)
})

test_that("skips and unexpected errors reset snapshots (r-lib/testthat#1393)", {
  regenerate <- FALSE

  if (regenerate) {
    withr::local_envvar(c(VDIFFR_REGENERATE_SNAPS = "true"))
  }

  suppressMessages(
    test_file(
      test_path("test-snapshot", "test-snapshot.R"),
      reporter = NULL
    )
  )

  expect_true(file.exists("test-snapshot/_snaps/snapshot/error-resets-snapshots.svg"))
  expect_true(file.exists("test-snapshot/_snaps/snapshot/skip-resets-snapshots.svg"))
})

test_that("`expect_doppelganger()` supports variants", {
  p1 <- ggplot2::ggplot()
  p2 <- ggplot2::ggplot() + ggplot2::geom_histogram()
  expect_doppelganger("variant", p1, variant = "foo")
  expect_doppelganger("variant", p2, variant = "bar")
})

context("Failed plots")
library("vdiffr")

p1_orig <- ggplot2::ggplot(mtcars, ggplot2::aes(disp)) + ggplot2::geom_histogram()
p1_fail <- p1_orig + ggplot2::geom_vline(xintercept = 300)

maintenance <- Sys.getenv("VDIFFR_REGENERATE_TESTS") == "yes"
skip_if_maintenance <- function() {
  if (maintenance) {
    skip("maintenance")
  }
}

test_that("mismatches are hard failures when NOT_CRAN is set", {
  skip_if_maintenance()
  expect_doppelganger("myplot", p1_fail, "")
})

test_that("Duplicated expectations issue a warning", {
  skip_if_maintenance()
  expect_doppelganger("myplot", p1_fail, "")
})

test_that("mismatches are hard failures when CI is set", {
  skip_if_maintenance()
  withr::local_envvar(c(NOT_CRAN = "", CI = "true"))
  expect_doppelganger("myplot", p1_fail, "")
})

test_that("mismatches are skipped when NOT_CRAN is unset", {
  skip_if_maintenance()
  withr::local_envvar(c(NOT_CRAN = "", CI = ""))
  expect_doppelganger("myplot", p1_fail, "")
})


# Maintenance --------------------------------------------------------

test_that("(maintenance) Reset failing figure", {
  if (!maintenance) {
    skip("maintenance")
  }
  expect_doppelganger("myplot", p1_orig, "")
})

context("utils")

test_that("can override is_ci()", {
  with_override <- function(var) {
    withr::with_envvar(c(VDIFFR_RUN_TESTS = var, CI = "", NOT_CRAN = ""), is_ci())
  }
  expect_true(with_override("true"))
  expect_false(with_override("false"))
  expect_error(with_override("falsish"), "must be")
})

vdiffr_skip_stale()
skip_if_not_installed("ggplot2")

test_that("ggtitle is set correctly", {
  p <- ggplot2::ggplot()
  expect_doppelganger("Some title", p)
  expect_doppelganger("Some other title", p + ggplot2::ggtitle(NULL))
})

context("Failing test")

original <- ggplot2::ggplot(mtcars)
failing <- ggplot2::ggplot(mtcars) + ggplot2::geom_vline(xintercept = 0)

test_that("this fails", {
  expect_doppelganger("failing", failing)
})

context("mismatch")

test_that("failures are pushed to log file", {
  log_path <- file.path(mock_pkg_dir, "tests", "vdiffr.Rout.fail")
  if (!file.exists(log_path)) {
    abort("Can't find log")
  }
  log <- readLines(log_path)

  n_logged <- length(grep("Failed doppelganger:", log))
  n_failures <- length(keep(mock_cases, inherits, "mismatch_case"))
  expect_identical(n_logged, n_failures)
})

context("Passed plots")
library("vdiffr")

test_that("ggplot doppelgangers pass", {
  p1_orig <- ggplot2::ggplot(mtcars, ggplot2::aes(disp)) + ggplot2::geom_histogram()
  expect_doppelganger("myplot", p1_orig, "")
})

test_that("base doppelgangers pass", {
  p_base <- function() plot(mtcars$disp)
  expect_doppelganger("myplot2", p_base, "")

  p_base_symbol <- function() {
    plot.new()
    text(0.5, 0.8, expression(x[i] + over(x, y)), font = 5)
  }

  expect_doppelganger("Base doppelganger with symbol", p_base_symbol, "")
})

library("grid")
test_that("grid doppelgangers pass", {
  p_grid <- function() {
    grid.newpage()
    grid.text("foobar", gp = gpar(fontsize = 10.1))
    grid.text("foobaz", 0.5, 0.1, gp = gpar(fontsize = 15.05))
  }
  expect_doppelganger("Grid doppelganger", p_grid)
})

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cases-ui.R
\name{vdiffrAddin}
\alias{vdiffrAddin}
\title{RStudio Addin for managing visual cases}
\usage{
vdiffrAddin()
}
\description{
The package is detected by looking for the currently active
project, then for the current folder if no project is active.
}
\seealso{
\code{\link[=manage_cases]{manage_cases()}}, \code{\link[=collect_cases]{collect_cases()}}, and \code{\link[=validate_cases]{validate_cases()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/expect-doppelganger.R
\name{expect_doppelganger}
\alias{expect_doppelganger}
\title{Does a figure look like its expected output?}
\usage{
expect_doppelganger(
  title,
  fig,
  path = deprecated(),
  ...,
  writer = write_svg,
  cran = FALSE,
  variant = NULL
)
}
\arguments{
\item{title}{A brief description of what is being tested in the
figure. For instance: "Points and lines overlap".

If a ggplot2 figure doesn't have a title already, \code{title} is
applied to the figure with \code{ggtitle()}.

The title is also used as file name for storing SVG (in a
sanitized form, with special characters converted to \code{"-"}).}

\item{fig}{A figure to test. This can be a ggplot object, a
recordedplot, or more generally any object with a \code{print} method.

If you need to test a plot with non-printable objects (e.g. base
plots), \code{fig} can be a function that generates and prints the
plot, e.g. \code{fig = function() plot(1:3)}.}

\item{path, ...}{\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}.}

\item{writer}{A function that takes the plot, a target SVG file,
and an optional plot title. It should transform the plot to SVG
in a deterministic way and write it to the target file. See
\code{\link[=write_svg]{write_svg()}} (the default) for an example.}

\item{cran}{If \code{FALSE} (the default), mismatched snapshots only
cause a failure when you run tests locally or in your CI (Github
Actions or any platform that sets the \code{CI} environment variable).
If \code{TRUE}, failures may also occur on CRAN machines.

Failures are disabled on CRAN by default because testing the
appearance of a figure is inherently fragile. Changes in the R
graphics engine or in ggplot2 may cause subtle differences in the
aspect of a plot, such as a slightly smaller or larger margin.
These changes will cause spurious failures because you need to
update your snapshots to reflect the upstream changes.

It would be distracting for both you and the CRAN maintainers if
such changes systematically caused failures on CRAN. This is why
snapshot expectations do not fail on CRAN by default and should
be treated as a monitoring tool that allows you to quickly check
how the appearance of your figures changes over time, and to
manually assess whether changes reflect actual problems in your
package.

Internally, this argument is passed to
\code{\link[testthat:expect_snapshot_file]{testthat::expect_snapshot_file()}}.}

\item{variant}{If not-\code{NULL}, results will be saved in
\verb{_snaps/{variant}/{test}/{name}.{ext}}. This allows you to create
different snapshots for different scenarios, like different operating
systems or different R versions.}
}
\description{
\code{expect_doppelganger()} is a testthat expectation for graphical
plots. It generates SVG snapshots that you can review graphically
with \code{\link[testthat:snapshot_accept]{testthat::snapshot_review()}}. You will find more information
about snapshotting in the \href{https://testthat.r-lib.org/articles/snapshotting.html}{testthat snapshots vignette}.

Note that \code{expect_doppelganger()} requires R version 4.1.0. If run
on an earlier version of R, it emits a \code{testthat::skip()} so that you
can still run other checks on old versions of R.
}
\section{Debugging}{

It is sometimes difficult to understand the cause of a failure.
This usually indicates that the plot is not created
deterministically. Potential culprits are:
\itemize{
\item Some of the plot components depend on random variation. Try
setting a seed.
\item The plot depends on some system library. For instance sf plots
depend on libraries like GEOS and GDAL. It might not be possible
to test these plots with vdiffr.
}

To help you understand the causes of a failure, vdiffr
automatically logs the SVG diff of all failures when run under R
CMD check. The log is located in \code{tests/vdiffr.Rout.fail} and
should be displayed on Travis.

You can also set the \code{VDIFFR_LOG_PATH} environment variable with
\code{Sys.setenv()} to unconditionally (also interactively) log failures
in the file pointed by the variable.
}

\examples{
if (FALSE) {  # Not run

library("ggplot2")

test_that("plots have known output", {
  disp_hist_base <- function() hist(mtcars$disp)
  expect_doppelganger("disp-histogram-base", disp_hist_base)

  disp_hist_ggplot <- ggplot(mtcars, aes(disp)) + geom_histogram()
  expect_doppelganger("disp-histogram-ggplot", disp_hist_ggplot)
})

}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/shiny-widgets.R
\name{shinybindings}
\alias{shinybindings}
\alias{toggleOutput}
\alias{renderToggle}
\alias{slideOutput}
\alias{slideTransition}
\alias{diffOutput}
\alias{diffTransition}
\title{Shiny bindings for graphical comparison widgets}
\usage{
toggleOutput(outputId, width = "100\%", height = "400px")

renderToggle(expr, env = parent.frame(), quoted = FALSE)

slideOutput(outputId, width = "100\%", height = "400px")

slideTransition(expr, env = parent.frame(), quoted = FALSE)

diffOutput(outputId, width = "100\%", height = "400px")

diffTransition(expr, env = parent.frame(), quoted = FALSE)
}
\arguments{
\item{outputId}{Output variable to read from.}

\item{width, height}{Must be a valid CSS unit (like \code{"100\\\%"},
\code{"400px"}, \code{"auto"}) or a number, which will be coerced to a
string and have \code{"px"} appended.}

\item{expr}{An expression that generates a comparison widget.}

\item{env}{The environment in which to evaluate \code{expr}.}

\item{quoted}{Is \code{expr} a quoted expression (with \code{quote()})? This
is useful if you want to save an expression in a variable.}
}
\description{
Output and render functions for using the Toggle, Slide and Diff
widgets within Shiny applications and interactive Rmd documents.
Used in \code{\link[=manage_cases]{manage_cases()}}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/testthat-ui.R
\name{add_dependency}
\alias{add_dependency}
\title{Add a vdiffr dependency}
\usage{
add_dependency(deps)
}
\arguments{
\item{deps}{A vector containing the names of the packages for which
a dependency should be added.}
}
\description{
It is useful to record the version number of all the packages on
which your visual test cases depend. A note containing a version
number is added to the \code{DESCRIPTION} file for each dependency.
Dependencies on svglite and ggplot2 are automatically added. In
addition, \code{add_dependency()} can be called in any testthat file to
manually add a dependency to a package.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vdiffr-package.R
\docType{package}
\name{vdiffr-package}
\alias{vdiffr}
\alias{vdiffr-package}
\title{vdiffr: Visual Regression Testing and Graphical Diffing}
\description{
An extension to the 'testthat' package that makes it easy to add graphical unit tests. It provides a Shiny application to manage the test cases.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://vdiffr.r-lib.org/}
  \item \url{https://github.com/r-lib/vdiffr}
  \item Report bugs at \url{https://github.com/r-lib/vdiffr/issues}
}

}
\author{
\strong{Maintainer}: Lionel Henry \email{lionel@posit.co}

Authors:
\itemize{
  \item Thomas Lin Pedersen \email{thomas.pedersen@posit.co} (\href{https://orcid.org/0000-0002-5147-4711}{ORCID})
  \item T Jake Luciani \email{jake@apache.org} (svglite)
  \item Matthieu Decorde \email{matthieu.decorde@ens-lyon.fr} (svglite)
  \item Vaudor Lise \email{lise.vaudor@ens-lyon.fr} (svglite)
}

Other contributors:
\itemize{
  \item Posit Software, PBC [copyright holder, funder]
  \item Tony Plate (svglite: Early line dashing code) [contributor]
  \item David Gohel (svglite: Line dashing code and raster code) [contributor]
  \item Yixuan Qiu (svglite: Improved styles; polypath implementation) [contributor]
  \item Håkon Malmedal (svglite: Opacity code) [contributor]
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cases.R
\name{validate_cases}
\alias{validate_cases}
\alias{delete_orphaned_cases}
\title{Cases validation}
\usage{
validate_cases(cases = collect_new_cases())

delete_orphaned_cases(cases = collect_orphaned_cases())
}
\arguments{
\item{cases}{A \code{cases} object returned by one of the collecting
functions such as \code{\link[=collect_cases]{collect_cases()}}.}
}
\description{
These functions are mainly intended for internal use by
\code{\link[=manage_cases]{manage_cases()}}. They are useful to programmatically validate
cases or delete orphaned cases.
}
\seealso{
\code{\link[=manage_cases]{manage_cases()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/svg.R
\name{write_svg}
\alias{write_svg}
\title{Default SVG writer}
\usage{
write_svg(plot, file, title = "")
}
\arguments{
\item{plot}{A plot object to convert to SVG. Can be a ggplot2 object,
a \link[grDevices:recordplot]{recorded plot}, or any object with a
\link[base:print]{print()} method.}

\item{file}{The file to write the SVG to.}

\item{title}{An optional title for the test case.}
}
\description{
This is the default SVG writer for vdiffr test cases. It uses
embedded versions of \href{https://svglite.r-lib.org}{svglite},
\href{https://harfbuzz.github.io/}{harfbuzz}, and the Liberation and
Symbola fonts in order to create deterministic SVGs.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/testthat-reporter.R
\name{last_collection_error}
\alias{last_collection_error}
\title{Print last error that occurred during collection}
\usage{
last_collection_error()
}
\description{
Print last error that occurred during collection
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cases-ui.R
\name{manage_cases}
\alias{manage_cases}
\title{Manage visual test cases with a Shiny app}
\usage{
manage_cases(
  package = ".",
  filter = NULL,
  invert = FALSE,
  ...,
  options = list()
)
}
\arguments{
\item{package}{Package description, can be path or package
name. See \code{\link[devtools:as.package]{devtools::as.package()}} for more information.}

\item{filter}{If not \code{NULL}, only tests with file names matching this
regular expression will be executed. Matching be performed on the file
name after it has been stripped of \code{"test-"} and \code{".R"}.}

\item{invert}{should the regexp supplied to \code{filter} be inverted? Defaults to \code{FALSE}.}

\item{...}{Unused.}

\item{options}{Named options that should be passed to the \code{runApp} call
(these can be any of the following: "port", "launch.browser", "host", "quiet",
"display.mode" and "test.mode"). You can also specify \code{width} and
\code{height} parameters which provide a hint to the embedding environment
about the ideal height/width for the app.}
}
\description{
Manage visual test cases with a Shiny app
}
\seealso{
\code{\link[=vdiffrAddin]{vdiffrAddin()}}, \code{\link[=collect_cases]{collect_cases()}}, and \code{\link[=validate_cases]{validate_cases()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/widgets.R
\name{htmlwidgets}
\alias{htmlwidgets}
\alias{widget_toggle_}
\alias{widget_slide_}
\alias{widget_diff_}
\alias{widget_toggle}
\alias{widget_slide}
\alias{widget_diff}
\title{HTML Widgets for graphical comparison}
\usage{
widget_toggle_(before, after, ..., width = NULL, height = NULL)

widget_slide_(before, after, ..., width = NULL, height = NULL)

widget_diff_(before, after, ..., width = NULL, height = NULL)

widget_toggle(before, after, ..., width = NULL, height = NULL)

widget_slide(before, after, ..., width = NULL, height = NULL)

widget_diff(before, after, ..., width = NULL, height = NULL)
}
\arguments{
\item{before}{The picture that is taken as reference.}

\item{after}{The picture against which the reference is compared.}

\item{...}{Unused. Meant for collecting unknown arguments and allow
widget extensions.}

\item{width}{Fixed width for widget (in css units). The default is
\code{NULL}, which results in intelligent automatic sizing based on the
widget's container.}

\item{height}{Fixed height for widget (in css units). The default is
\code{NULL}, which results in intelligent automatic sizing based on the
widget's container.}
}
\description{
These widgets can be used at the console and embedded in a R
Markdown document or Shiny application.
}
\details{
The regular versions take plots or functions as \code{before} and
\code{after} arguments (see \code{\link[=expect_doppelganger]{expect_doppelganger()}} for details). The
versions suffixed with underscores take HTML image sources. These
can be paths to SVG files or inlined SVG images. Currently,
\code{widget_diff_()} is compatible only with inlined images.
}
\examples{
p1 <- function() hist(mtcars$disp)
p2 <- function() hist(mtcars$drat)

# You can also call these functions in a R Markdown document or
# in a Shiny application:
widget_toggle(p1, p2)
widget_slide(p1, p2)
widget_diff(p1, p2)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cases.R
\name{collect_cases}
\alias{collect_cases}
\alias{collect_new_cases}
\alias{collect_mismatched_cases}
\alias{collect_orphaned_cases}
\title{Collect cases}
\usage{
collect_cases(package = ".", filter = NULL, invert = FALSE)

collect_new_cases(package = ".")

collect_mismatched_cases(package = ".")

collect_orphaned_cases(package = ".")
}
\arguments{
\item{package}{Package description, can be path or package
name. See \code{\link[devtools:as.package]{devtools::as.package()}} for more information.}

\item{filter}{If not \code{NULL}, only tests with file names matching this
regular expression will be executed. Matching be performed on the file
name after it has been stripped of \code{"test-"} and \code{".R"}.}

\item{invert}{should the regexp supplied to \code{filter} be inverted? Defaults to \code{FALSE}.}
}
\value{
A \code{cases} object. \code{collect_new_cases()},
\code{collect_mismatched_cases()} and \code{collect_orphaned_cases()}
return a filtered \code{cases} object.
}
\description{
These functions are mainly intended for internal use by
\code{\link[=manage_cases]{manage_cases()}}. They are useful to programmatically collect
cases.
}
\seealso{
\code{\link[=manage_cases]{manage_cases()}}
}
